/* 
menu.c 
ALICE V 2.0, January 1993
library functions for menu handling 
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#define __GEMLIB_OLDNAMES
#include <gem.h> 
#include <osbind.h> 
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include "language.h" 
#include "prvdef.h" 
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "structs.h" 
#include "rsc.h" 
 
 
/* References to global data defined elsewhere  */ 
 
extern  short			ap_id, VDIhandle; 
extern  short     bzeich, hzeich; 
extern  WIND_DATA windows[]; 
extern  BUFFER    buffers[]; 
extern  OBJECT    *menu_tree; 
extern  OBJECT    *dial_about, *dial_help, *dial_print; 
extern  OBJECT    *dial_search, *dial_replace, *dial_gotoli; 
extern  OBJECT    *dial_info, *dial_selebuf, *dial_options; 
extern  OBJECT    *dial_repl_info, *dial_gotopa, *dial_helpfi;
extern	OBJECT		*dial_helpms, *dial_helpbl, *dial_helpwi;
extern  OBJECT    *dial_pinfo;

extern  long  	param_line; 
extern  int   	prgquit, prgexit, page_length, left_margin; 
extern  int   	tab_size, backup, clocky, header, lines;
extern  int   	showcr, showpos; 
extern  int   	buffer_index, line_len, eol_warn; 
extern  int   	from_page, to_page, page_offset, closeall;
extern	int			sea_direct,	sea_case, sea_start;
extern	int			repl_case, repl_verify, repl_start;
extern  char  	default_name[], save_as_name[], filename[]; 
extern  char  	filename_save[], default_path[]; 
extern  char  	save_as_path[], search_string[]; 
extern  char  	search_string_save[], text[], old_name[]; 
extern  char  	new_name[], info_string[], param_filename[]; 
extern  char    sea_str[], sea_str_cfg[], repl_str[], repl_str_cfg[];
extern  char    replby_str[], replby_str_cfg[];

// Function-Prototypes
short block_set(short w_index); 
void buf_enable(int flag); 
void cap_check(int w_index); 
void clear_block_flags(short w_index); 
short copy_block(short w_index);
int create_file(char *filename, int w_index);
short cursor(short w_handle, short mode); 
short cursor_visible_check(short w_index); 
void delete_block(int w_index);
int delete_file(void);
void display_pos(int w_index);
void display_time(short flag); 
void doc_info(void);
int do_replace(void);
short easy_open_window(char *w_name, 
										 	 void (*redraw)(short w_handle, GRECT *area, short clear), 
										 	 short w_index); 
int exist_buffer(void); 
int exist_wind(void); 
short full_redraw(short w_handle, short clear); 
void goto_line(short w_index, long line);
short handle_dial(OBJECT *dial_tree, short start_obj); 
void handle_options(void);
int handle_print(void);
int get_free_index(void); 
short get_index_from_handle(short w_handle); 
short HighWord(char *str);
int init_include_buffer(void);
int init_buffer(int b_index);
int line_length(int  w_index, long number); 
long max(long a, long b);
long min(long a, long b);
void output(short w_handle, GRECT *area, short clear); 
int own_top_wind(void); 
int paste_block(int w_index);
int paste_include_file(int w_index);
void put_message(int msg_nr);
int read_file(char *filename, int w_index);
int read_file_buffer(char *filename, int b_index);
int read_include_file(char *filename);
void refresh_window(int w_handle);
int rk_strrchr(char str[], char c);
void say(char *string); 
int search(int w_index, long search_start_x, long search_start_y, 
           int search_direction, char *search_string, int search_case, 
           long *found_x, long *found_y); 
void select_buffer(void);
int top_wind(void); 
int write_file(char *filename, int w_index); 


/**********************/ 
/* Start of routines  */ 
/**********************/ 

 
/* main routine for menu handling  */ 
 

short handle_menu(short title, short item) 
{ 
  long    curs_x, curs_y, doc_w, doc_h, check; 
  long    found_x, found_y, search_start_x, search_start_y; 
  long    num_lines, go_line, go_page; 
  int     /*rtc, exit_button,*/ offset, i, a; 
  short		exit_button, rtc;
  short   w_handle = 0, w_index, item_hit, cleared = 0; 
  int     search_direction = 0, search_case, search_case_save;
  int     found, /*send_buffer[MSG_BUFFER],*/ num_pages;
  short		send_buffer[MSG_BUFFER];
  int     new_file, search_direction_save;
  int			search_start_save;
  TEDINFO *ted_info = NULL; 
  FILE    *fp; 

  if ((closeall || prgquit) && (item != IBACK)) 	return (TRUE); 
  new_file = FALSE;
  w_index = -1; 
  memset(send_buffer, (int) 0, (size_t) MSG_BUFFER);
  send_buffer[1] = ap_id; 
  send_buffer[2] = 0; 
  rtc = TRUE; 
  default_path[0] = 'A'; 
  default_path[0] += Dgetdrv(); 
  default_path[1] = ':'; 
  Dgetpath(default_path + 2, 0); 
  strcpy (filename, default_path); 
  strcpy (filename + strlen (filename), "\\"); 
  strcpy (default_path + strlen (default_path), "\\*.*"); 
  strcpy (save_as_path, default_path); 
  strcpy (save_as_name, ""); 

  wind_update(BEG_UPDATE); 

  switch (item) 
  {                                             /* 1. switch start  */ 
    case  IABOUT: 
				    			handle_dial (dial_about, 0); 
				          break; 

    case  IOPEN: 
          		    new_file = FALSE;
									w_index = get_free_index();
                  if (w_index == -1)	/* no more window available	*/ 
                  {
	                  menu_ienable(menu_tree, IOPEN, FALSE); 
                    put_message(NO_MORE_WIND);
                    rtc = FALSE; 
                    break; 
                  } 

                  if (strlen(param_filename) != 0) 
                  { 
                    strcpy (default_name, param_filename); 
                  } 

                  if (!fsel_input(default_path, default_name, &exit_button)) 
                  { 
                    break; 
                  } 
                  if (exit_button == 0)         /* "cancel"-option  */ 
                  { 
                    break; 
                  } 

                  if (strlen (default_name) == 0          || 
                      default_name[0] == '.'              ||
                      default_path[1] != ':'              ||
                      default_path[2] != '\\')  /* syntax check */
                  { 
                    put_message (INVAL_FNAME); 
                    break; 
                  } 
                  menu_ienable(menu_tree, IOPEN, FALSE); 
                                     					/* "temporarily disable open" */ 
                  if (strcmp (default_name, param_filename))
                  {
                    param_line = 0;
                  }
                  												/* assemble the complete filename */ 
                  strcpy (filename, default_path); 
                  offset = (int)max((long)0, (long)rk_strrchr(filename, '\\')); 
                              				/* get the position of  the last '\' */ 
                  strcpy (filename + offset, default_name); 
                  if (Fsfirst(filename, 0) != 0)       			/* new file */ 
                  { 
# ifdef english
                    exit_button = form_alert ( 
                    1, "[2][ Create new file ? ][ Yes | No ]"); 
# endif
# ifdef german
                    exit_button = form_alert ( 
                    1, "[2][ Datei neu anlegen ? ][ Ja | Nein ]"); 
# endif
# ifdef french
                    exit_button = form_alert ( 
                    1, "[2][ Cr\202er le fichier ? ][ Oui | Non ]"); 
# endif
                    if (exit_button != 1) 
                    { 
                      menu_ienable(menu_tree, IOPEN, TRUE); 
                              				/* cancel "termporarily disable open" */ 
                      break; 
                    }
                    new_file = TRUE; 
                    MOUSE_IS_BUSY;
                    if (!create_file(filename, w_index)) 
                    { 
                      windows[w_index].head   = NULL; 
                      windows[w_index].handle = -1; 
                      menu_ienable(menu_tree, IOPEN, TRUE); 
                              				/* cancel "termporarily disable open" */ 
                      rtc = FALSE; 
                      break; 
                    } 
                  } 
                  MOUSE_IS_BUSY; 
                  if (!read_file(filename, w_index)) 
                  { 
                    windows[w_index].head   = NULL; 
                    windows[w_index].handle = -1; 
                    menu_ienable(menu_tree, IOPEN, TRUE); 
                              /* cancel "termporarily disable open" */ 
                    rtc = FALSE; 
                    break; 
                  } 
                  for (i = 0; i < WD_MAX_WINDOWS; i++) 
                  {                            /* hide all cursors  */ 
                    w_handle = windows[i].handle; 
                    if (w_handle != -1) cursor(w_handle, 0); 
                  } 

                  easy_open_window(filename, output, w_index); 
                  menu_ienable(menu_tree, ICLOSE, 	TRUE); 
                  menu_ienable(menu_tree, IRDFILFI, TRUE); 
                  menu_ienable(menu_tree, ICLOSALL, TRUE); 
                  menu_ienable(menu_tree, IDOCINFO, TRUE); 
                  menu_ienable(menu_tree, IGOTOLI,  TRUE); 
                  menu_ienable(menu_tree, IGOTOPA,  TRUE); 
                  menu_ienable(menu_tree, ISAVE, 	  TRUE); 
                  menu_ienable(menu_tree, ISAVEAS,  TRUE); 
                  menu_ienable(menu_tree, IBACK, 	  TRUE); 
                  menu_ienable(menu_tree, IBACKAS,  TRUE); 
                  menu_ienable(menu_tree, IFIPRINT, TRUE); 
                  menu_ienable(menu_tree, ISEARCH,  TRUE); 
                  menu_ienable(menu_tree, IREPL,		TRUE); 
                  ted_info = dial_search[SEASTRG].ob_spec.tedinfo; 
                  if (strlen (ted_info->te_ptext) > 0) 
                  { 
                    menu_ienable (menu_tree, IREPSEAR,TRUE); 
                  } 
                  menu_ienable (menu_tree, IBLSTART, TRUE); 
                  menu_ienable (menu_tree, IBLEND,   TRUE); 
                  cap_check(w_index);  							/* cut and paste check  */ 
                  menu_ienable (menu_tree, IOPEN, TRUE); 
                  										/* cancel "termporarily disable open" */ 
                  										/* update default drive/path */ 
                  Dsetdrv (filename[0] - 'A'); 
                  offset = (int)max((long)0, 
                  									(long)rk_strrchr(default_path, '\\')); 
                  strcpy (default_path + offset, "\0"); 
                  Dsetpath(default_path); 
                  if (new_file) Fdelete (filename);
                  new_file = FALSE;
                  if (param_line != 0) 
                  {
                    goto_line(w_index, param_line); 
                  }
                  if (get_free_index () == -1)	
                  {
	                  menu_ienable(menu_tree, IOPEN, FALSE); 
                  } 
                  break; 

    case  ICLOSE: 
                  if (!own_top_wind()) 	break; 
                  send_buffer[0] = WM_CLOSED; 
                  send_buffer[3] = top_wind(); 
                  appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
                  break; 

    case IBACK:   											/* up to closing the active window */ 
    case ISAVE:   													/* these options are identical */ 
                  w_index = get_index_from_handle (top_wind ()); 
                  if (w_index == -1) break;
                  if (!own_top_wind ())
                  {
                    if (!closeall && !prgquit) break;
                  } 
                  MOUSE_IS_BUSY; 
                  if (item == IBACK)
                  {
                    strcpy(info_string, INFO_BACK); 
                  }
                  else
                  {
                    strcpy(info_string, INFO_SAVE); 
                  }
                  wind_set(windows[w_index].handle, WF_INFO,    
                           HighWord(info_string), (short)info_string, 0, 0);
                  strcpy(old_name, windows[w_index].file_name); 
                  strcpy(new_name, old_name); 
                  if (strrchr (new_name, '.') != NULL) 
                  { 
                    strcpy (strrchr (new_name, '.'), BCK_EXTENSION); 
                  } 
                  else 
                  { 
                    strcpy (new_name + strlen (new_name), BCK_EXTENSION); 
                  } 

               	  if (backup) 						/* save the old version	*/
             	    {
           	   	  	remove (new_name);
										rename (old_name, new_name);
                  }
									
                  if (write_file (windows[w_index].file_name, w_index)) 
                  { 
                    if (item == IBACK) 
                    {         				/* send a message to close the window */ 
                      windows[w_index].modified = FALSE;
                      send_buffer[0] = WM_CLOSED; 
                      send_buffer[3] = windows[w_index].handle; 
                      appl_write(ap_id, (short)sizeof(send_buffer), 
                      					 send_buffer); 
                    } 
                    else 
                    { 
                      strcpy(windows[w_index].wind_name, 
                             windows[w_index].file_name); 
                      wind_set(windows[w_index].handle, WF_NAME, 
                               HighWord(windows[w_index].wind_name), 
                               (short)(windows[w_index].wind_name), 0, 0); 
                      windows[w_index].modified = FALSE; 
                    } 
                  } 
                  else 
                  { 
                    put_message (FILE_NOT_SAVED); 
                    display_pos (w_index);
                    rtc = FALSE; 
                    break;
                  } 
                  display_pos (w_index);
                  break; 

    case  IBACKAS:   									/* up to closing the active window  */ 
    case  ISAVEAS:   									/* these options are identical      */ 
                  w_handle = top_wind();
                  w_index = get_index_from_handle (top_wind ()); 
                  if (w_index == -1 || !own_top_wind ())	break; 
                  if (!fsel_input(save_as_path, save_as_name, &exit_button)) 
                  	break; 
                  if (exit_button == 0)		break;  			/* "cancel"-option  */
                  refresh_window (w_handle); 
                  if ((strlen (save_as_name) == 0) || (save_as_name[0] == '.')) 
                  { 
                    put_message (INVAL_FNAME);
                  } 
                  												/* assemble the complete filename */ 
                  strcpy (filename, save_as_path); 
                  offset = (int)max((long)0, (long)rk_strrchr(filename, '\\')); 
                              					/* get the position of  the last '\' */ 
                  strcpy (filename + offset, save_as_name); 
                  if (Fsfirst (filename, 0) == 0)   					/* file exists */ 
                  { 
# ifdef english
                    exit_button = form_alert (2, 
        "[2][ File already exists | Replace it ? ][ Yes | No ]"); 
# endif
# ifdef german
                    exit_button = form_alert (2, 
        "[2][ Datei existiert schon | Ersetzen ? ][ Ja | Nein ]"); 
# endif
# ifdef french
                    exit_button = form_alert (2, 
"[2][ Le fichier d\202j\205 existe | Le remplacer ? ][ Oui | Non ]"); 
# endif
                    if (exit_button == 2) 
                    {
                      display_pos (w_index);
                      break; 
                    }
                    strcpy (old_name, filename); 
                    strcpy (new_name, old_name); 
                    if (strrchr (new_name, '.') != NULL) 
                    { 
                      strcpy (strrchr (new_name, '.'), 
                              BCK_EXTENSION); 
                    } 
                    else 
                    { 
                      strcpy (new_name + strlen (new_name), 
                              BCK_EXTENSION); 
                    } 
                    MOUSE_IS_BUSY; 
                    if (item == IBACKAS)
                    {
                      strcpy (info_string, INFO_BACK); 
                    }
                    else
                    {
                      strcpy (info_string, INFO_SAVE); 
                    }
                    wind_set(windows[w_index].handle, WF_INFO,    
                             HighWord(info_string), (short)info_string, 0, 0);

               	  	if (backup) 			/* save the old version	*/
             	    	{
											remove (new_name);
											rename (old_name, new_name);
	                  }
                    if ((fp = fopen (filename, "w")) == (FILE *) NULL) 
                    { 
                      put_message (FILE_NOT_DELETED);
                      rtc = FALSE;
                      display_pos (w_index);
                      break; 
                    } 
                    fclose (fp); 
                    rtc = Fdelete (filename); 
                    if (rtc != 0)                 /* error occurred */ 
                    { 
                      put_message (FILE_NOT_DELETED);
                      display_pos (w_index);
                      rtc = FALSE;
                      break; 
                    } 
                  } 
                  MOUSE_IS_BUSY; 
                  if (item == IBACKAS)
                  {
                    strcpy (info_string, INFO_BACK); 
                  }
                  else
                  {
                    strcpy (info_string, INFO_SAVE); 
                  }
                  wind_set(windows[w_index].handle, WF_INFO,    
                           HighWord(info_string), (short)info_string, 0, 0);
                  strcpy (filename_save, windows[w_index].file_name); 
                  strcpy (windows[w_index].file_name, filename); 
                  if (write_file (windows[w_index].file_name,
                  								w_index)) 
                  { 
                    if (item == IBACKAS) 
                    {         				/* send a message to close the window */
                      windows[w_index].modified = FALSE;
                      send_buffer[0] = WM_CLOSED; 
                      send_buffer[3] = windows[w_index].handle; 
                      appl_write(ap_id, (short)sizeof(send_buffer), 
                      					 send_buffer); 
                    } 
                    else    /* restore the old filename */
                    { 
                      strcpy (windows[w_index].file_name, filename_save); 
                    } 
                  } 
                  else 
                  { 
                    strcpy (windows[w_index].file_name, filename_save);
                    put_message (FILE_NOT_SAVED); 
                    rtc = FALSE; 
                    display_pos (w_index);
                    break; 
                  } 
                  /* update default drive and path */ 
                  Dsetdrv (filename[0] - 'A'); 
                  offset = (int)max((long)0, 
                  									(long)rk_strrchr (save_as_path, '\\')); 
                             /* get the position of  the last '\' */ 
                  strcpy (save_as_path + offset, "\0"); 
                  Dsetpath (save_as_path); 
                  display_pos (w_index);
                  break;

    case IFIPRINT: 
									handle_print ();
                  break; 
                  
    case IOPTIONS: 
									handle_options ();
									break;
									
    case IGOTOLI: 
                  w_index = get_index_from_handle(top_wind()); 
                  if (w_index == -1 || !own_top_wind ()) 	break; 
                  ted_info = dial_gotoli[LINEGOTO].ob_spec.tedinfo; 
                  sprintf(text, "%ld", windows[w_index].curs_y); 
                  strcpy(ted_info->te_ptext, text); 
                  item_hit = handle_dial(dial_gotoli, LINEGOTO); 
                  if (item_hit == CANCGOTO) 	break; 
                  go_line = atol(ted_info->te_ptext);
                  goto_line(w_index, go_line);
                  break; 

    case IGOTOPA: 
                  w_index = get_index_from_handle(top_wind()); 
                  if (w_index == -1 || !own_top_wind()) 	break; 
                  ted_info = dial_gotopa[PAGEGOTO].ob_spec.tedinfo; 
                  if (dial_print[HEADYES].ob_state == SELECTED)
                  {
                    a = page_length - 2;
                  }
                  else
                  {
                    a = page_length;
                  }
                  i = (int)((windows[w_index].curs_y - 1 ) / a);
                  i++;
                  sprintf(text, "%d", i); 
                  strcpy(ted_info->te_ptext, text); 
                  item_hit = handle_dial (dial_gotopa, PAGEGOTO); 
                  if (item_hit == CANCGOPA) 	break; 
                  go_page   = atol(ted_info->te_ptext);
                  num_lines = windows[w_index].doc_length / hzeich; 
                  num_pages = (int)((num_lines - 1 ) / a);
                  num_pages++;
                  go_page = min(go_page, (long)num_pages);
                  go_line = (go_page - 1) * a + 1;
                  goto_line(w_index, go_line);
                  break; 

    case IDOCINFO: 
									doc_info();
                  break; 

    case  IQUIT: 
                  if (exist_wind())  /* there is an open window  */ 
                  { 
                    check = FALSE; 
                    for (i = 0; i < WD_MAX_WINDOWS; i++) 
                    { 
                      if ((windows[i].handle != -1) && (windows[i].modified)) 
                      	check = TRUE; 
                    } 

                    if (check) 
                    { 
# ifdef english
                      exit_button = form_alert (1, 
                        "[2][ Really quit ? ][ Yes | No ]"); 
# endif
# ifdef german
                      exit_button = form_alert (1, 
                        "[2][ Wirklich Ende ? ][ Ja | Nein ]"); 
# endif
# ifdef french
                      exit_button = form_alert (1, 
                        "[2][ Quitter vraiment ? ][ Oui | Non ]"); 
# endif
                      if (exit_button != 1) 	break; 
                    }
                 
                    if (own_top_wind())
                    {
                      w_index = get_index_from_handle(top_wind());
                      strcpy(param_filename, windows[w_index].file_name); 
                      param_line = windows[w_index].curs_y; 
                    }
                  } 

                  prgquit = TRUE; 
                  if (!exist_wind())   /* no need for cleanup  */ 
                  { 
                    prgexit = TRUE; 
                    break; 
                  } 
							                  /* send a message to close the top window */ 
                  send_buffer[0] = WM_CLOSED; 
                  send_buffer[3] = top_wind(); 
									appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
                  break; 

    case  ICLOSALL: 
                  if (!exist_wind()) 	break;
                  if (!own_top_wind()) 	break; 
                  closeall = TRUE;
                  								/* send a message to close the top window */ 
                  send_buffer[0] = WM_CLOSED; 
                  send_buffer[3] = top_wind (); 
                  appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
                  break; 

    case  IHELPKBD: 
                  handle_dial (dial_help, 0); 
                  break; 

    case  IHELPFI: 
                  handle_dial (dial_helpfi, 0); 
                  break; 

    case  IHELPBL: 
                  handle_dial (dial_helpbl, 0); 
                  break; 

    case  IHELPMS: 
                  handle_dial (dial_helpms, 0); 
                  break; 

    case  IHELPWI: 

                  handle_dial (dial_helpwi, 0); 
                  break; 

    case  IFIDELE: 
                  if (!delete_file ()) rtc = FALSE; 
                  break; 

    case ISEARCH: 
                  if ((w_handle = top_wind ()) == -1) break; 
                  w_index = get_index_from_handle(w_handle); 
                  if (w_index == -1 || !own_top_wind()) break; 
                  ted_info = dial_search[SEASTRG].ob_spec.tedinfo; 
                  strcpy (search_string_save, ted_info->te_ptext); 
                  search_direction_save =  
                    							(dial_search[SEAFORW].ob_state == SELECTED); 
                  search_start_save =  
                    								(dial_search[SEATOP].ob_state == SELECTED); 
                  search_case_save =  
                    							(dial_search[SCASEYES].ob_state == SELECTED); 
                  item_hit = handle_dial (dial_search, SEASTRG); 
                  if (item_hit == SEACANC) 
                  {                   				/* restore previous settings  */
                    ted_info = dial_search[SEASTRG].ob_spec.tedinfo; 
                    strcpy (ted_info->te_ptext, search_string_save); 
                    if (search_direction_save)
                    {
                      objc_change (dial_search, SEAFORW,  
                                    0, 0, 0, 0, 0, SELECTED, 0); 
                      objc_change (dial_search, SEABACKW,  
                                    0, 0, 0, 0, 0, NORMAL, 0); 
                    }
                    else
                    {
                      objc_change (dial_search, SEABACKW,  
                                    0, 0, 0, 0, 0, SELECTED, 0); 
                      objc_change (dial_search, SEAFORW,  
                                    0, 0, 0, 0, 0, NORMAL, 0); 
                    }

                    if (search_case_save)
                    {
                      objc_change (dial_search, SCASEYES,  
                                    0, 0, 0, 0, 0, SELECTED, 0); 
                      objc_change (dial_search, SCASENO,  
                                    0, 0, 0, 0, 0, NORMAL, 0); 
                    }
                    else
                    {
                      objc_change (dial_search, SCASENO,  
                                    0, 0, 0, 0, 0, SELECTED, 0); 
                      objc_change (dial_search, SCASEYES,  
                                    0, 0, 0, 0, 0, NORMAL, 0); 
                    }

                    if (search_start_save)
                    {
                      objc_change (dial_search, SEATOP,  
                                    0, 0, 0, 0, 0, SELECTED, 0); 
                      objc_change (dial_search, SEACURS,  
                                    0, 0, 0, 0, 0, NORMAL, 0); 
                    }
                    else
                    {
                      objc_change (dial_search, SEACURS,  
                                    0, 0, 0, 0, 0, SELECTED, 0); 
                      objc_change (dial_search, SEATOP,  
                                    0, 0, 0, 0, 0, NORMAL, 0); 
                    }
                    break;
                  } 
                  ted_info = dial_search[SEASTRG].ob_spec.tedinfo; 
                  memset(search_string, (int)0, (size_t)(WD_MAX_EDIT_LENGTH));
                  strcpy(search_string, ted_info->te_ptext); 
                  if (dial_search[SEATOP].ob_state == SELECTED) 
                  { 
                    search_start_x 	= 1; 
                    search_start_y 	= 1; 
										sea_start				= TRUE;
                  } 
                  else                          				/* radio buttons... */ 
                  { 
                    search_start_x 	= windows[w_index].curs_x; 
                    search_start_y 	= windows[w_index].curs_y; 
										sea_start				= FALSE;
                  } 
									                              				/* radio buttons... */ 
                  search_direction = (dial_search[SEAFORW].ob_state == SELECTED); 
                  search_case = (dial_search[SCASEYES].ob_state == SELECTED); 
									sea_direct 	= search_direction;
									sea_case 		= search_case;
									strcpy (sea_str, search_string);
                  if (strlen (search_string) == 0) 
                  { 
                    menu_ienable (menu_tree, IREPSEAR,FALSE); 
                    break; 
                  } 
                  found_x = 1; 
                  found_y = 1; 
                  MOUSE_IS_BUSY; 
                  found = search(w_index,  					/* initiate the search  */ 
                                 search_start_x, search_start_y, 
                                 search_direction, search_string, search_case,
                                 &found_x, &found_y); 
                  MOUSE_IS_ARROW; 
                  w_handle = windows[w_index].handle;
                  if (!found) 
                  { 
                    put_message (STRING_NOT_FOUND); 
                  } 
                  else 
                  { 
									  graf_mouse(M_OFF, NULL);
                    cursor(w_handle, 0); 						/* hide the text cursor */ 
                    windows[w_index].curs_x  = found_x; 
                    windows[w_index].curs_xs = found_x; 
                    windows[w_index].curs_y  = found_y; 
                    if (!cursor_visible_check(w_index)) 
                    {                   /* recalc the new document position */ 
                      curs_y  = (windows[w_index].curs_y - 1) * hzeich; 
                      doc_h   = windows[w_index].work.g_h; 
                      windows[w_index].doc_y = 
                      									max((long)curs_y - doc_h/2, (long)0); 
                      curs_x  = (windows[w_index].curs_x - 1) * bzeich; 
                      doc_w   = windows[w_index].work.g_w; 
                      if (!(windows[w_index].doc_x == 0 && curs_x + 1 <= doc_w)) 
                      { 
                        windows[w_index].doc_x = 
                          							max((long)curs_x - doc_w/2, (long)0); 
                      }
                        								/* send myself a full redraw message */ 
                      send_buffer[0] = WM_REDRAW; 
                      send_buffer[3] = w_handle; 
                      send_buffer[4] = windows[w_index].work.g_x; 
                      send_buffer[5] = windows[w_index].work.g_y; 
                      send_buffer[6] = windows[w_index].work.g_w; 
                      send_buffer[7] = windows[w_index].work.g_h; 
                      appl_write(ap_id, (short)sizeof(send_buffer), 
                      					 send_buffer); 
                    } 
                    else 
                    { 
                      cursor(w_handle, 1);   	/* show the cursor */ 
                    } 
 										graf_mouse(M_ON, NULL);
                  } 
                  menu_ienable (menu_tree, IREPSEAR,TRUE); 
                  break; 

    case IREPSEAR: 
                  if ((w_handle = top_wind ()) == -1) 	break; 
                  w_index = get_index_from_handle(w_handle); 
                  if (w_index == -1 || !own_top_wind()) 	break; 
 
                  for (i = 0; i < WD_MAX_EDIT_LENGTH; i++) 
                  {
                    search_string[i] = '\0';
                  }
                  
                  ted_info = dial_search[SEASTRG].ob_spec.tedinfo; 
                  strcpy (search_string, ted_info->te_ptext); 
                  if (strlen (search_string) == 0) 
                  { 
                    break; 
                  } 
										                             				/* radio buttons... */ 
                  search_direction = 
                  							(dial_search[SEAFORW].ob_state == SELECTED); 
                  search_case = (dial_search[SCASEYES].ob_state == SELECTED); 
                  if (search_direction == 1) 
                  {                                 				/* 1. if start  */ 
                    search_start_x = windows[w_index].curs_x + 1; 
                    search_start_y = windows[w_index].curs_y; 
                    if (search_start_x >= line_length(w_index, 
                                       					windows[w_index].curs_y) && 
                        search_start_y != windows[w_index].doc_length/hzeich) 
                    {                               				/* 2. if start  */ 
                      search_start_x = 1; 
                      search_start_y++; 
                      if (windows[w_index].doc_length/hzeich < search_start_y) 
                      { 
                        search_start_y = windows[w_index].doc_length/hzeich; 
                      } 
                    }                                 				/* 2. if end  */ 
                    if (line_length(w_index, search_start_y) < search_start_x) 
                    { 
                      search_start_x = line_length(w_index, search_start_y); 
                    } 
                  } 
                  else                      /* search_direction = 0 */ 
                  { 
                    search_start_x = windows[w_index].curs_x - 1; 
                    search_start_y = windows[w_index].curs_y; 
                    if (search_start_x <= 0 && search_start_y != 1) 
                    {                               				/* 2. if start  */ 
                      search_start_y--; 
                      search_start_y = max((long)search_start_y, (long)1); 
                      search_start_x = line_length(w_index, search_start_y); 
                    }                                 				/* 2. if end  */ 
                    search_start_x = max((long)search_start_x, (long)1); 
                  }                                   				/* 1. if end  */ 
                  found_x = 1; 
                  found_y = 1; 
                  MOUSE_IS_BUSY; 
                  found = search(w_index,  				/* initiate the search  */ 
                                 search_start_x, search_start_y, 
                                 search_direction, search_string,
                                 search_case, &found_x, &found_y); 
                  MOUSE_IS_ARROW; 
                  if (!found) 
                  { 
                    put_message (STRING_NOT_FOUND); 
                  } 
                  else 
                  { 
  									graf_mouse(M_OFF, NULL);
                    cursor(w_handle, 0); 						/* hide the text cursor */ 
                    windows[w_index].curs_x  = found_x; 
                    windows[w_index].curs_xs = found_x; 
                    windows[w_index].curs_y  = found_y; 
                    if (!cursor_visible_check(w_index)) 
                    { 
                      									/* recalc the new document position */ 
                      curs_y  = (windows[w_index].curs_y - 1) * hzeich; 
                      doc_h   = windows[w_index].work.g_h; 
                      windows[w_index].doc_y = 
                      										max((long)curs_y - doc_h/2, (long)0); 
                      curs_x  = (windows[w_index].curs_x - 1) * bzeich; 
                      doc_w   = windows[w_index].work.g_w; 
                      if (!(windows[w_index].doc_x == 0 && curs_x + 1 <= doc_w)) 
                      { 
                        windows[w_index].doc_x = 
                          								max((long)curs_x - doc_w/2, (long)0); 
                      } 
                      full_redraw(w_handle, TRUE); 
                    } 
                    else 
                    { 
                      cursor(w_handle, 1);   /* show the cursor... */ 
                    } 
  									graf_mouse(M_ON, NULL);
                  } 
                  break; 

    case  IREPL: 
                  do_replace ();
                  break; 

    case  IBLSTART: 
                  if ((w_handle = top_wind()) == -1) 	break; 
                  w_index = get_index_from_handle(w_handle); 
                  if (w_index == -1 || !own_top_wind()) 	break; 
  								graf_mouse(M_OFF, NULL);
                  cursor(w_handle, 0); 
                  windows[w_index].block.cs_x = windows[w_index].curs_x; 
                  windows[w_index].block.cs_y = windows[w_index].curs_y; 
                  if (block_set(w_index)) 
                  { 
                    windows[w_index].block.set = TRUE; 
                  } 
                  else 
                  { 
                    windows[w_index].block.set = FALSE; 
                  } 
                  cap_check(w_index);
                  full_redraw(w_handle, FALSE); 
                    /* this is one of the few calls to full_redraw  */ 
                    /* with the clear flag set to FALSE. this is    */ 
                    /* because the screen is simply to be redrawn   */ 
                    /* in order to show the block marks.            */ 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  break; 

    case  IBLEND: 
                  if ((w_handle = top_wind()) == -1) 	break; 
                  w_index = get_index_from_handle(w_handle); 
                  if (w_index == -1 || !own_top_wind()) 	break; 
  								graf_mouse(M_OFF, NULL);
                  cursor(w_handle, 0); 
                  windows[w_index].block.ce_x = windows[w_index].curs_x; 
                  windows[w_index].block.ce_y = windows[w_index].curs_y; 
                  if (block_set (w_index)) 
                  { 
                    windows[w_index].block.set = TRUE; 
                  } 
                  else 
                  { 
                    windows[w_index].block.set = FALSE; 
                  } 
                  cap_check(w_index);
                  full_redraw(w_handle, FALSE); 
			                    /* this is one of the few calls to full_redraw  */ 
			                    /* with the clear flag set to FALSE. this is    */ 
			                    /* because the screen is simply to be redrawn   */ 
			                    /* in order to show the block marks.            */ 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  break; 

    case  IBLCANC:                            				/* cancel block marks */ 
                  if ((w_handle = top_wind ()) == -1) 	break; 
                  w_index = get_index_from_handle(w_handle); 
                  if (w_index == -1 || !own_top_wind()) 	break; 
  								graf_mouse(M_OFF, NULL);
                  cursor(w_handle, 0); 
                  if (windows[w_index].block.set == TRUE) 
                  { 
                  	clear_block_flags (w_index);
                    full_redraw (w_handle, FALSE); 
			                    /* this is one of the few calls to full_redraw  */ 
			                    /* with the clear flag set to FALSE. this is    */ 
			                    /* because the screen is simply to be redrawn   */ 
			                    /* in order to clear the block marks.           */ 
                  } 
                  cap_check(w_index); 
                  cursor(w_handle, 1); 
  								graf_mouse(M_ON, NULL);
                  break; 

    case  IRDFILBU:                       				/* read file into buffer  */
									strcpy(default_name, BUFFER_FILE);	
														/* make sure the user is aware of the operation	*/
                  if (!fsel_input(default_path, default_name, &exit_button)) 
                  { 
                    break; 
                  } 
                  if (exit_button == 0)         /* "cancel"-option  */ 
                  { 
                    break; 
                  } 
                  if ((strlen (default_name) == 0) || 
                      (default_name[0] == '.')) 
                  { 
                    put_message (INVAL_FNAME); 
                    break; 
                  } 
                  												/* assemble the complete filename */ 
                  strcpy(filename, default_path); 
                  offset = (int) max ((long) 0, 
                            (long) rk_strrchr (filename, '\\')); 
                              				/* get the position of  the last '\' */ 
                  strcpy (filename + offset, default_name); 
                  if (Fsfirst (filename, 0) != 0)       			/* new file */ 
                  { 
                    put_message (FILE_NOT_FOUND);
                    rtc = FALSE; 
                    break; 
                  } 
                  MOUSE_IS_BUSY; 
                  if (!read_file_buffer (filename, buffer_index)) 
                  { 
                    init_buffer (buffer_index);
                    rtc = FALSE; 
                    break; 
                  } 
                  														/* update default drive/path */ 
                  Dsetdrv (filename[0] - 'A'); 
                  offset = (int) max ((long) 0, 
                            (long) rk_strrchr (default_path, '\\')); 
                              				/* get the position of  the last '\' */ 
                  strcpy (default_path + offset, "\0"); 
                  Dsetpath (default_path); 
                  if (exist_wind () && own_top_wind ())
                  {
                  	w_index = get_index_from_handle (top_wind ());
                  	cap_check (w_index);
                  }
                  else
                  { 
                    menu_ienable (menu_tree, IBLPASTE, FALSE); 
                  }
                  switch (buffer_index)
                  {
                    case 0: 
                      ted_info = 
                            dial_selebuf[BUFNAM1].ob_spec.tedinfo; 
                      break;
                    case 1: 
                      ted_info = 
                            dial_selebuf[BUFNAM2].ob_spec.tedinfo; 
                      break;
                    case 2: 
                      ted_info = 
                            dial_selebuf[BUFNAM3].ob_spec.tedinfo; 
                      break;
                    case 3: 
                      ted_info = 
                            dial_selebuf[BUFNAM4].ob_spec.tedinfo; 
                      break;
                    case 4: 
                      ted_info = 
                            dial_selebuf[BUFNAM5].ob_spec.tedinfo; 
                      break;
                    case 5: 
                      ted_info = 
                            dial_selebuf[BUFNAM6].ob_spec.tedinfo; 
                      break;
                    case 6: 
                      ted_info = 
                            dial_selebuf[BUFNAM7].ob_spec.tedinfo; 
                      break;
                    case 7: 
                      ted_info = 
                            dial_selebuf[BUFNAM8].ob_spec.tedinfo; 
                      break;
                    case 8: 
                      ted_info = 
                            dial_selebuf[BUFNAM9].ob_spec.tedinfo; 
                      break;
                    case 9: 
                      ted_info = 
                            dial_selebuf[BUFNAM10].ob_spec.tedinfo; 
                      break;
                    default:  
                      say ("Nasty buffer error");
                      break;
                  }
                  strcpy(ted_info->te_ptext, default_name);
									menu_ienable (menu_tree, ICLBUFF,  TRUE); 
                  break;

    case  IRDFILFI:                             						/* include file */
                  if ((w_handle = top_wind ()) == -1) break; 
                  w_index = get_index_from_handle(w_handle); 
                  if (w_index == -1 || !own_top_wind()) break; 
                  if (block_set (w_index)) 
                  { 
                    put_message (CANCEL_BLMARKS); 
                    rtc = FALSE; 
                    break; 
                  } 
									strcpy (default_name, INCL_FILE);
														/* make sure the user is aware of the operation	*/
                  if (!fsel_input (default_path, 
                                   default_name, 
                                   &exit_button)) break;
                  if (exit_button == 0)         				/* "cancel"-option  */ 
                  { 
                    break; 
                  } 
                  if ((strlen (default_name) == 0) || 
                      (default_name[0] == '.')) 
                  { 
                    put_message (INVAL_FNAME); 
                    break; 
                  } 
                  /* assemble the complete filename */ 
                  strcpy (filename, default_path); 
                  offset = (int) max ((long) 0, 
                            (long) rk_strrchr (filename, '\\')); 
                              				/* get the position of  the last '\' */ 
                  strcpy (filename + offset, default_name); 
                  if (Fsfirst (filename, 0) != 0) 			/* file not found */ 
                  { 
                    put_message (FILE_NOT_FOUND);
                    rtc = FALSE; 
                    break; 
                  } 
                  MOUSE_IS_BUSY; 
                  strcpy (info_string, INFO_INCLUDE);
                  wind_set(windows[w_index].handle, WF_INFO,    
                           HighWord(info_string), (short)info_string, 0, 0);
                  if (!read_include_file (filename)) 
                  { 
                    init_include_buffer ();
                    rtc = FALSE;
                    display_pos (w_index); 
                    break; 
                  } 
                  													/* update default drive/path */ 
                  Dsetdrv (filename[0] - 'A'); 
                  offset = (int)max((long)0, 
                  									(long)rk_strrchr (default_path, '\\')); 
                              				/* get the position of  the last '\' */ 
                  strcpy (default_path + offset, "\0"); 
                  Dsetpath (default_path); 
                  if ((rtc = paste_include_file (w_index)) != TRUE) 
                  { 
                    put_message (BLOCK_NOT_INSERTED); 
                  } 
                  windows[w_index].modified   = TRUE; 
									clear_block_flags (w_index);
                  refresh_window (w_handle); 
                  init_include_buffer ();
                  cap_check (w_index);
                  display_pos (w_index);
                  break;

    case  ICLBUFF:                                 /* clear buffer */ 
                  if (!exist_buffer ()) 
                  {                                /* 1. if start  */ 
                    put_message (BUFFER_EMPTY); 
                    menu_ienable (menu_tree, ICLBUFF,  FALSE); 
                    menu_ienable (menu_tree, IBLPASTE, FALSE); 
                  } 
                  else 
                  { 
                    cleared = 0; 
                    i = buffer_index;
                    if (!buffers[i].used) 
                    {                              /* 2. if start  */ 
# ifdef english
                      exit_button = form_alert (2, 
        "[2][ Buffer unused | Clear it ? ][ Yes | No ]"); 
# endif
# ifdef german
                      exit_button = form_alert (2, 
        "[2][ Puffer unbenutzt | Lschen ? ][ Ja | Nein ]"); 
# endif
# ifdef french
                      exit_button = form_alert (2, 
        "[2][ Tampon pas utilis\202 | Effacer ? ][ Oui | Non ]"); 
# endif
                      if (exit_button == 1) 
                      {                            /* 3. if start  */ 
                        MOUSE_IS_BUSY; 
                        init_buffer (i); 
                        put_message (BUFFER_CLEARED); 
                        cleared++; 
                      }                              /* 3. if end  */ 
                    } 
                    else 
                    { 
                      MOUSE_IS_BUSY; 
                      init_buffer (i); 
                      put_message (BUFFER_CLEARED); 
                      cleared++; 
                    }                                /* 2. if end  */ 
                  }                                  /* 1. if end  */ 
                  if (cleared) 
                  { 
                    buf_enable (FALSE); 
                  } 
                  break; 

    case  ISELEBUF:                                /* select buffer */ 
									select_buffer ();
                  break; 

    case IBLCUT:    				/* copy block into buffer and delete from text */ 
                  if ((w_handle = top_wind ()) == -1) break; 
                  w_index = get_index_from_handle(w_handle); 
                  if (w_index == -1 || !own_top_wind()) break; 
                  if (!block_set (w_index)) 
                  { 
                    put_message (NO_BLDEF);
                    cap_check (w_index); 
                    rtc = FALSE; 
                    break; 
                  } 
                  MOUSE_IS_BUSY; 
                  if ((rtc = copy_block (w_index)) != TRUE) 
                  { 
                    put_message (BLOCK_NOT_COPIED); 
                  } 
                  else 
                  { 
                    delete_block (w_index); 
										clear_block_flags (w_index);
                    windows[w_index].modified   = TRUE; 
                    refresh_window (w_handle);
                    buf_enable (TRUE); 
                    cap_check (w_index);
                  } 
                  break; 

    case IBLCOPY: 
                  if ((w_handle = top_wind ()) == -1) break; 
                  w_index = get_index_from_handle (w_handle); 
                  if (w_index == -1 || !own_top_wind()) break; 
                  if (!block_set (w_index)) 
                  { 
                    put_message (NO_BLDEF); 
                    cap_check (w_index);
                    rtc = FALSE; 
                    break; 
                  } 
                  MOUSE_IS_BUSY; 
                  if ((rtc = copy_block (w_index)) != TRUE) 
                  { 
                    put_message (BLOCK_NOT_COPIED); 
                  } 
									clear_block_flags (w_index);
                  refresh_window (w_handle); 
                  cap_check (w_index); 
                  break; 

    case IBLPASTE: 
                  if ((w_handle = top_wind ()) == -1) break; 
                  w_index = get_index_from_handle(w_handle); 
                  if (w_index == -1 || !own_top_wind()) break; 
                  if (block_set (w_index)) 
                  { 
                    put_message (CANCEL_BLMARKS); 
                    rtc = FALSE; 
                    break; 
                  } 
                  if (!exist_buffer ()) 
                  { 
                    put_message (BUFFER_EMPTY); 
                    menu_ienable (menu_tree, ICLBUFF,  FALSE); 
                    menu_ienable (menu_tree, IBLPASTE,  FALSE); 
                    rtc = FALSE; 
                    break; 
                  } 
                  MOUSE_IS_BUSY; 
                  if ((rtc = paste_block (w_index)) != TRUE) 
                  { 
                    put_message (BLOCK_NOT_INSERTED); 
                  } 
                  windows[w_index].modified   = TRUE; 
                  clear_block_flags (w_index);
                  refresh_window (w_handle); 
                  cap_check (w_index);
                  break; 

    case IBLDELE: 
                  if ((w_handle = top_wind ()) == -1) break; 
                  w_index = get_index_from_handle (w_handle); 
                  if (w_index == -1 || !own_top_wind()) break; 
                  if (!block_set (w_index)) 
                  { 
                    put_message (NO_BLDEF);
                    cap_check (w_index); 
                    rtc = FALSE; 
                    break; 
                  } 
                  MOUSE_IS_BUSY; 
                  delete_block (w_index); 
									clear_block_flags (w_index);
                  windows[w_index].modified   = TRUE; 
                  refresh_window (w_handle);
                  cap_check (w_index); 
                  break; 

    default:      break; 
  }                                               /* 1. switch end  */ 

  if (w_index != -1 && rtc == TRUE) 
  { 
    if (windows[w_index].modified == TRUE && 
        windows[w_index].wind_name[0] != MOD_CHAR) 
    { 
      for (i = (int)strlen(windows[w_index].wind_name) + 1; i > 0; i--) 
      { 
        (windows[w_index].wind_name)[i] =     /* shift the letters  */ 
         (windows[w_index].wind_name)[i-1]; 
      } 
      (windows[w_index].wind_name)[0] = MOD_CHAR; 
                                          /* mark text as modified  */ 
      wind_set(w_handle, WF_NAME,          /* set the window name  */ 
               HighWord(windows[w_index].wind_name), 
               (short)(windows[w_index].wind_name), 0, 0); 
    } 
  } 
  menu_tnormal(menu_tree, title, TRUE); 
  display_time(clocky);  
	MOUSE_IS_ARROW;
  wind_update(END_UPDATE);
  return (rtc); 
}                                     /* end function handle_menu */ 

/* end of file menu.c  */ 
 
