/* 
message.c 
ALICE V 2.0, January 1993
message routines 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#include <gem.h>
#include <stdio.h> 
#include <string.h> 
#include <time.h>
#include "language.h" 
#include "prvdef.h" 
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "rsc.h"
 
 
 
/* References to global data define elsewhere */ 
 
extern  short	VDIhandle;
extern	char	prg_path[];

 
/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
 
void put_message(int msg_nr) 
//int   msg_nr;               /* message_number */ 
{ 

	if (msg_nr != NO_RSC) 
  {
	  graf_mouse(M_ON, NULL);
  	MOUSE_IS_ARROW; 
 	}
 	
  switch(msg_nr) 
  { 
    case  INVAL_FNAME: 
 
# ifdef english
            form_alert (1, "[3][ Invalid filename ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Ungltiger Dateiname ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
              "[3][ Nom de fichier | invalide ][ OK ]"); 
            break; 
# endif
 

    case  NO_MORE_WIND: 
 
# ifdef english
            form_alert (1, 
              "[1][ No more window | available... | "
              "Please close any | open window. ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, 
              "[1][ Kann kein weiteres | Fenster mehr ffnen...| "
              "Bitte ein anderes Fenster | schlieen. ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
              "[1][ Plus de fen\210tres | disponibles...| "
              "Fermez une fen\210tre | ouverte.][ OK ]"); 
            break; 
# endif
 


    case  GEM_INIT_ERROR: 
 
# ifdef english
            form_alert (1, "[3][ Error in gem_init ][ Quit ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Fehler in gem_init ][ Ende ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
            "[3][ Erreur lors | de gem_init ][ Fin ]"); 
            break; 
# endif


    case  NONPRINTABLE_CHARACTERS: 
 
# ifdef english
            form_alert (1, 
            	"[1][ File contains nonprintable |"
            	" characters | Be carefull ! ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, 
            	"[1][ Datei enthlt |"
            	" nicht-druckbare Zeichen | Vorsicht ! ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
            "[1][ Le fichier contient des |"
            " charact\212res non imprimables | Attention ! ][ OK ]"); 
            break; 
# endif


    case  FILE_NOT_FOUND: 

# ifdef english
            form_alert (1, "[3][ File not found ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Datei nicht gefunden ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Fichier pas trouv\202 ][ OK ]"); 
            break; 
# endif


    case  FILE_NOT_DELETED: 
 
# ifdef english
            form_alert (1, "[3][ File not deleted ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Datei nicht gelscht ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Fichier pas effac\202 ][ OK ]"); 
            break; 
# endif


    case  FILE_DELETED: 
 
# ifdef english
            form_alert (1, "[1][ File deleted ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[1][ Datei gelscht ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[1][ Fichier effac\202 ][ OK ]"); 
            break; 
# endif
 

    case  CANCEL_BLMARKS: 
    
# ifdef english
            form_alert (1, 
       "[3][ Cancel block marks | before modifying text ][ OK ]"); 
            break;
# endif
# ifdef german
            form_alert (1, 
       "[3][ Vor Textnderungen | Markierungen lschen ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
  "[3][ Effacer les marques | avant de modifier | le texte ][ OK ]"); 
            break; 
# endif


    case  NO_PRINT_SETUP: 
 
# ifdef english
            form_alert (2, 
              "[3][ No proper printer setup ][ Try | again ]"); 
            break; 
# endif
# ifdef german
            form_alert (2, 
         "[3][ Ungltige | Drucker-Einstellung ][ Noch | mal ]"); 
            break; 
# endif
# ifdef french
            form_alert (2, 
              "[3][ Param\212tres invalides | "
              "pour l'imprimante ][ Encore | s.v.p. ]"); 
            break; 
# endif
 

    case  NO_TAB_SIZE: 

#ifdef english
            form_alert (1, 
              "[3][ No proper tab size ][ Repeat | it ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, 
         "[3][ Ungltige | Tabulator-Gre ][ Noch | mal ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
  "[3][ Valeur invalide | pour le tabulateur ][ Encore ]"); 
            break; 
# endif
 

    case  NO_LINE_LEN: 

# ifdef english
            form_alert (1, 
              "[3][ No proper line length ][ Once | more ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, 
              "[3][ Ungltige | Zeilenlnge ][ Noch | mal ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
              "[3][ Longeur de ligne | invalide ][ Encore ]"); 
            break; 
# endif
 


    case  BUFFER_EMPTY: 

# ifdef english
            form_alert (1, "[3][ Nothing in Buffer ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Puffer ist leer ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Le tampon est vide ][ OK ]"); 
            break; 
# endif
 

    case  BUFFER_CLEARED: 
 
# ifdef english
            form_alert (1, "[1][ Buffer cleared ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[1][ Puffer gelscht ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[1][ Tampon effac\202 ][ OK ]"); 
            break; 
# endif
 

    case  NO_BLDEF: 
 
# ifdef english
            form_alert (1, "[3][ No proper block defined ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Kein Block definiert ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
              "[3][ Pas de bloque | defini ][ OK ]"); 
            break; 
# endif
 

    case  STRING_NOT_FOUND: 
 
# ifdef english
            form_alert (1, "[1][ String not found ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[1][ Text nicht gefunden ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[1][ Texte pas trouv\202 ][ OK ]"); 
            break; 
# endif
 

    case  OUT_OF_MEMORY: 
 
# ifdef english
            form_alert (1, "[3][ Out of memory ! | "
                          "Quit program and | "
                          "restart computer... ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Speicher reicht nicht ! | "
                          "Programm beenden | "
                          "und Rechner neu starten... ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Plus de memoire ! | "
                          "Quitte  le logiciel | "
                          "et reset l'ordinateur... ][ OK ]"); 
            break; 
# endif


    case  LINE_TOO_LONG: 
 
# ifdef english
            form_alert (1, 
            "[3][ Hoops ! | Line too long ][ Cancel ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, 
            "[3][ Hoppla ! | Zeile zu lang ][ Abbruch ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
            "[3][ Hopl\205 ! | Ligne trop longue ][ Abandon ]"); 
            break; 
# endif


    case  BLOCK_NOT_COPIED: 
 
# ifdef english
            form_alert (1, "[3][ Block not copied ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Block nicht kopiert ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Bloque pas copi\202 ][ OK ]"); 
            break; 
# endif


    case  BLOCK_NOT_INSERTED: 
 
# ifdef english
            form_alert (1, 
              "[3][ Block not | completely inserted ][ OK ]"); 
            break; 
# endif

# ifdef german
            form_alert (1, 
              "[3][ Block nicht | vollstndig eingefgt ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
          "[3][ Bloque pas ins\202r\202 | compl\212tement ][ OK ]"); 
            break; 
# endif
 

    case  PRINTER_ERROR: 
 
# ifdef english
            form_alert (1, "[3][ Printing error ][ Abort ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Fehler beim Drucken ][ Abbruch ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
            "[3][ Erreur lors | de l'impression ][ Abandon ]"); 
            break; 
# endif

    case  PRINTER_BUSY: 
 
# ifdef english
            form_alert (1, "[3][ Printer not available ][ Abort ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, 
              "[3][ Drucker nicht verfgbar ][ Abbruch ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
            "[3][ L'imprimante n'est pas | disponible ][ Abandon ]"); 
            break; 
# endif

    case  NO_LOW_REZ: 
 
# ifdef english
            form_alert (1, 
"[3][ Running low rez means | asking for trouble ... ][ Quit ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, 
      "[3][ Niedrige Auflsung | macht keinen Sinn... ][ Ende ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
      "[3][ Pas de r\202solution | basse... ][ Fin ]"); 
            break; 
# endif


    case  NO_RSC: 

						printf ("\n\n ALICE - Another Little C Editor \n");
						printf (" Version %s, " 
						 "Copyright \275 1992/93 by %s.\n", 
						 ALICE_VERSION, ALICE_AUTHOR);
						
 
#ifdef english
            printf (
             "\n *** RSC-File %s not found in directory \n"
             " *** %s.\n", 
             RSC_FILE,
             prg_path);
						printf (" *** End of program !\n");
            printf (" *** Press <Return> to continue...");
            getchar (); 
            break; 
# endif
# ifdef german
            printf (
             "\n *** RSC-Datei %s nicht gefunden "
             "im Verzeichnis \n"
             " *** %s.\n",
             RSC_FILE,
             prg_path);
            printf (" *** Programmende !\n");
            printf (" *** Bitte <Return> Taste drcken...");
//            getchar(); 
            break; 
# endif
# ifdef french
            printf (
             "\n *** Fichier RSC %s pas trouv\202 dans \n"
             " *** %s.\n", 
             RSC_FILE,
             prg_path);
            printf (" *** Fin du programme !\n");
            printf (" *** Appuye sur <Return> pour continuer...");
            getchar (); 
            break; 
# endif

 
    case  ERR_OPEN_FILE: 
 
# ifdef english
            form_alert (1, "[3][ Cannot open file ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Kann Datei | "
                           "nicht ffnen ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Ne peut pas | "
                           "ouvrir le fichier ][ OK ]"); 
            break; 
# endif
 

    case  ERR_CREATE_FILE: 
 
# ifdef english
            form_alert (1, "[3][ Cannot create file ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Kann Datei | "
                           "nicht anlegen ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Ne peut pas cr\202er | "
                           "le fichier ][ OK ]"); 
            break; 
# endif
 

    case  ERR_AT_WRITE: 
 
# ifdef english
            form_alert (1, "[3][ Error at write. | "
                           "Disk full or | "
                           "write protection ? ][ Quit ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Fehler beim Schreiben. | "
                           "Disk voll oder | "
                           "Schreibschutz ? ][ Ende ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Erreur lors de l'\202criture | "
                           "Plus d'espace sur la disque | "
                           "ou protection d'\202criture ? ][ Fin ]"); 
            break; 
# endif
 


    case  FILE_NOT_SAVED: 
 
# ifdef english
            form_alert (1, "[3][ File not saved. | "
                           "Disk full or | "
                           "write protection ? ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Datei nicht gespeichert. | "
                           "Disk voll oder | "
                           "Schreibschutz ? ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Fichier pas sauv\202 | "
                           "Plus d'espace sur la disque | "
                           "ou protection d'\202criture ? ][ OK ]"); 
            break; 
# endif
 


    case  ERR_AT_CLOSE: 
 
# ifdef english
            form_alert (1, "[3][ Cannot close file ][ Quit ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Kann Datei | "
                           "nicht schlieen ][ Ende ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Ne peut pas fermer | "
                           "le fichier ][ Fin ]"); 
            break; 
# endif
 

    case  FILE_EMPTY: 
 
# ifdef english
            form_alert (1, "[3][ File is empty ][ OK ]"); 
            break; 

# endif
# ifdef german
            form_alert (1, "[3][ Datei ist leer ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Le fichier est vide ][ OK ]"); 
            break; 
# endif
 

    case  ERR_CFG_WRITE: 
 
# ifdef english
            form_alert (1, "[3][ Cannot write | "
                           "config file ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Kann CFG-Datei | "
                           "nicht schreiben ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Ne peut pas \202crire | "
                           "le fichier CFG ][ OK ]"); 
            break; 
# endif


    case  ERR_CFG_READ: 
 
# ifdef english
            form_alert (1, "[3][ Cannot read | "
                           "config file ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Kann CFG-Datei | "
                           "nicht lesen ][ OK ]"); 
            break; 
# endif
# ifdef french

            form_alert (1, "[3][ Ne peut pas lire | "
                           "le fichier CFG ][ OK ]"); 
            break; 
# endif
 

    case  PRINT_INTERRUPTED: 
 
# ifdef english

            form_alert (1, "[3][ Printing aborted ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Ausdruck abgebrochen ][ OK ]"); 
            break; 
# endif
# ifdef french

            form_alert (1, "[3][ Impression interrompue ][ OK ]"); 
            break; 
# endif
 

    case  PRG_NOT_TERMINATED: 
 
# ifdef english
            form_alert (1, "[3][ Program continues... ][ OK ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, "[3][ Programm geht weiter... ][ OK ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, "[3][ Le logiciel continue... ][ OK ]"); 
            break; 
# endif
 

    default: 
 
# ifdef english
            form_alert (1, 
            "[3][ Undefined message number ][ Sorry ]"); 
            break; 
# endif
# ifdef german
            form_alert (1, 
            "[3][ Undefinierte Nachricht ][ Schade ]"); 
            break; 
# endif
# ifdef french
            form_alert (1, 
            "[3][ Message ind\202fini ][ Dommage ]"); 
            break; 
# endif
 
  } 
  return; 
}                           /* end of function put_message  */




void repl_message(long count)
//long  count;
{
  char  question[ALERT_MAX_LINES * ALERT_MAX_LINE_LENGTH]; 


  MOUSE_IS_ARROW;
  
# ifdef english
  sprintf (question, 
  "[1][ That was it... | %ld replacement(s) ][ Thanks ]", count); 
# endif
# ifdef german
  sprintf (question, 
  "[1][ Das war's... | %ld Ersetzung(en) ][ Danke ]", count); 
# endif
# ifdef french
  sprintf (question, 
  "[1][ C'est ca... | %ld remplacement(s) ][ Merci ]", count); 
# endif

  form_alert (1, question); 
  return;
}                       /* end of function repl_message */
 
 
 
/* end of file message.c  */

