/* 
toolbox.c 
ALICE V 2.0, January 1993
collection of miscellaneous utility routines 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#include <ctype.h> 
#define __GEMLIB_OLDNAMES
#include <gem.h> 
#include <osbind.h> 
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include <time.h>
#include "language.h" 
#include "prvdef.h" 
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "structs.h" 
#include "rsc.h"
 
 
/* References to global data define elsewhere */ 
 
extern  short     ap_id, VDIhandle; 
extern  WIND_DATA windows[]; 
extern  BUFFER    buffers[]; 
extern  BUFFER    include_buffer; 
extern  int       os_major, os_minor; 
extern  short     hzeich, bzeich; 
extern  MFDB      screen, src, dst; 
 
extern  OBJECT      *menu_tree; 
extern  OBJECT      *dial_about, *dial_help, *dial_print, *dial_tab; 
extern  OBJECT      *dial_search, *dial_replace, *dial_gotoli; 
extern  OBJECT      *dial_info; 
extern  OBJECT      *dial_helpfi, *dial_helpms;
extern  OBJECT      *dial_helpbl, *dial_helpwi;
 
extern    int       tab_size, tab_size_cfg, backup, backup_cfg; 
extern    int       clocky, clocky_cfg, showcr, showcr_cfg; 
extern    int       showpos, showpos_cfg; 
extern    int       page_length, page_length_cfg; 
extern    int       left_margin, left_margin_cfg; 
extern    int       header, header_cfg, lines, lines_cfg;
extern    int       line_len_cfg, line_len, eol_warn, eol_warn_cfg;

extern    int       sea_direct, sea_direct_cfg;
extern    int       sea_case, sea_case_cfg;
extern    int       sea_start, sea_start_cfg;
extern    int       repl_case, repl_case_cfg;
extern    int       repl_verify, repl_verify_cfg;
extern    int       repl_start, repl_start_cfg;

extern    char      sea_str[], sea_str_cfg[];
extern    char      repl_str[], repl_str_cfg[];
extern    char      replby_str[], replby_str_cfg[];
 
extern    int       prg_drive; 
extern    char      prg_path[]; 
extern    char      param_filename[];
extern    char      filename_cfg[];
extern		char			text[];
extern    long      param_line; 
extern    long      line_cfg; 

// Funktionsprototypen
void buf_enable(int flag); 
void cap_enable(int flag); 
short cursor(short w_handle, short mode); 
long first_match(char p[], char q[], int respect_case);
short full_redraw(short w_handle, short clear); 
long last_match(char p[], int n, char q[], int respect_case);
long max(long a, long b);
long min(long a, long b);
void put_graphic_char(char c, short x, short y, short w_index); 
void say(char *string); 

 
/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
 
/*--------------------------------------------------------------------
	Copy screen area  
--------------------------------------------------------------------*/ 
void rcopy(short xs, short ys, short ws, short hs, short xd, short yd, 
					 short mode)
{ 
  short pxyarray[8]; 

  src.fd_addr     =  dst.fd_addr      = screen.fd_addr; 
  src.fd_w        =  dst.fd_w         = screen.fd_w; 
  src.fd_h        =  dst.fd_h         = screen.fd_h; 
  src.fd_stand    =  dst.fd_stand     = 0; 
  src.fd_wdwidth  =  dst.fd_wdwidth   = screen.fd_wdwidth; 
  src.fd_nplanes  =  dst.fd_nplanes   = screen.fd_nplanes; 
 
  pxyarray[0] = xs; 
  pxyarray[1] = ys; 
  pxyarray[2] = xs+ws; 
  pxyarray[3] = ys+hs; 
  pxyarray[4] = xd; 
  pxyarray[5] = yd; 
  pxyarray[6] = xd+ws; 
  pxyarray[7] = yd+hs; 
 
  vro_cpyfm(VDIhandle, mode, pxyarray, &src, &dst); 
  return; 
} 
 
 
LINE_DESC *create_list_element(void) 
{ 
  LINE_DESC *p; 
 
  p = (LINE_DESC *) malloc (sizeof (LINE_DESC)); 
  if (p) 
  { 
    p->line   = NULL; 
    p->prev   = NULL; 
    p->next   = NULL; 
    p->len    = 0; 
    p->size   = 0; 
  } 
  return (p); 
} 
 
 
LINE_DESC *line_ptr(int w_index, size_t number)  /* returns pointer to line  */ 
//int       w_index; 
//size_t    number;                       /* "number" in window with  */ 
                                        /* index "w_index"          */ 
{ 
  long        i; 
  LINE_DESC   *p; 
 
  if (windows[w_index].head == NULL) return (0); 
  p = windows[w_index].head; 
  for (i = 1; i < number; i++) 
  { 
    p = p->next; 
  } 
  /* now p points to the line in question */ 
 
  return (p); 
} 
 
 
int line_length(int w_index, long number) /* returns the length of line */ 
//int   w_index; 
//long  number;                       /* "number" in window with    */ 
                                    /* index "w_index"            */ 
{ 
  int        i; 
  LINE_DESC   *p; 
 
  if (windows[w_index].head == NULL) return (0); 
  p = windows[w_index].head; 
  for (i = 1; i < number; i++) 
  { 
    p = p->next; 
  } 
  /* now p points to the line in question */ 
  return (p->len); 
} 
 
 
void add_element(LINE_DESC *e, int w_index) 
//LINE_DESC *e; 
//int       w_index; 
{ 
  LINE_DESC *p; 
 
  /* if the first element (the head of the list) has not  */ 
  /* been created yet, create it now                      */ 
 
  if (windows[w_index].head == NULL) 
  { 
    windows[w_index].head = e; 
    return; 
  } 
  /* otherwise, find the last element in the list         */ 
  for (p = windows[w_index].head; p->next != NULL; p = p->next) 
  { 
    ;         /* null statement */ 
  } 
  p->next = e;            /* add e to the end of the list */ 
  e->prev = p; 
  return; 
} 
 
 
void add_element_buffer(LINE_DESC *e, int b_index) 
//LINE_DESC *e; 
//int       b_index; 
{ 
  LINE_DESC *p; 
 
  /* if the first element (the head of the list) has not  */ 
  /* been created yet, create it now                      */ 
 
  if (buffers[b_index].head == NULL) 
  { 
    buffers[b_index].head = e; 
    return; 
  } 
  /* otherwise, find the last element in the list         */ 
  for (p = buffers[b_index].head; p->next != NULL; p = p->next) 
  { 
    ;         /* null statement */ 
  } 
  p->next = e;            /* add e to the end of the list */ 
  e->prev = p; 
  return; 
}                         /* end of function add_element_buffer */
 
 
void add_element_include_buffer(LINE_DESC *e) 
//LINE_DESC *e; 
{ 
  LINE_DESC *p; 
 
  /* if the first element (the head of the list) has not  */ 
  /* been created yet, create it now                      */ 
 
  if (include_buffer.head == NULL) 
  { 
    include_buffer.head = e; 
    return; 
  } 
  /* otherwise, find the last element in the list         */ 
  for (p = include_buffer.head; p->next != NULL; p = p->next) 
  { 
    ;         /* null statement */ 
  } 
  p->next = e;            /* add e to the end of the list */ 
  e->prev = p; 
  return; 
}                 /* end of function add_element_include_buffer */
 
 
/* routine for string-expanding: expands \t into b blanks   */ 
 
void rk_strexp(char *p, int b) 
//char  *p;                   /* input/output string    */ 
//int   b;                    /* expand size            */ 
{ 
  char    q[MAX_LINE+1], r[MAX_LINE+1]; 
  int     i, j, k; 

  b = (int) max ((long) 1, (long) b); 
  memset (q, 0, MAX_LINE);
  memset (r, 0, MAX_LINE);
  if (strlen (p) >= MAX_LINE-1) 
  {
    p[MAX_LINE-2] = '\0';   /* truncate */
  }
  strcpy (q, p); 
  i = 0; 
  j = 0; 
  while (((r[i] = q[j]) != 0)         && 
          i < MAX_LINE - tab_size - 2 && 
          j < MAX_LINE - tab_size - 2)
  {                                 /* 1. while start */ 
    switch (r[i]) 
    {                             /* 1. switch start  */ 
      case  '\t': 
                  for (k = i % b; k < b; k++) 
                  {                   /* 1. for start */ 
                    r[i] = ' '; 
                    i++; 
                  }                     /* 1. for end */ 
                  j++; 
                  break; 
      default   : i++; 
                  j++; 
                  break; 
    }                               /* 1. switch end  */
  }                                   /* 1. while end */ 
  if (i) strcpy (r + i - 1, "\n"); 
  strcpy (p, r); 
  return; 
}                           /* end function rk_strexp */ 
 
 
/*  my own routine for strrchr                                */ 
/*  locates the last occurrence of character c in string str  */ 
/*  and returns its offset (if present) or -1 (otherwise)     */ 
 
int rk_strrchr(char str[], char c) 
//char  str[],c; 
{ 
  int   i, length; 
  char  *chptr; 
 
  chptr  = str; 
  length = 0; 
  while (*chptr++)  length++;       /* get the string length  */ 
  for (i = length; i > 0; i--) 
  { 
    if (str[i-1] == c)  return (i); 
  } 
  return (-1); 
}                                 /* end function rk_strrchr  */ 
 
 
/* checks whether the cursor is within the visible window area  */ 
 
short cursor_visible_check(short w_index) 
//int   w_index; 
{ 
  long  start_x, start_y; 
  int   wind_w, wind_h, visible; 
 
  start_x = windows[w_index].doc_x / bzeich; 
  start_y = windows[w_index].doc_y / hzeich; 
  wind_w  = windows[w_index].work.g_w / bzeich; 
  wind_h  = windows[w_index].work.g_h / hzeich; 
 
  visible = TRUE; 
  if ((windows[w_index].curs_y < start_y + 1)       || 
      (windows[w_index].curs_y > start_y + wind_h)  || 
      (windows[w_index].curs_x < start_x + 1)       || 
      (windows[w_index].curs_x > start_x + wind_w)) 
  { 
    visible = FALSE; 
  } 
  return (visible); 
}                             /* end of function cursor_visible */ 
 
 
int search (int w_index, long search_start_x, long search_start_y, 
            int search_direction, char *search_string, int respect_case,
            long *found_x, long *found_y) 
/*int   w_index; 
long  search_start_x, search_start_y; 
int   search_direction; 
char  *search_string;
int   respect_case; 
long  *found_x, *found_y; */
{ 
  size_t        i, line_count, forward, offset = 0, match_index; 
  int           max_pos = 0; 
  LINE_DESC     *p; 
 
  forward = (search_direction == 1); 
  p = windows[w_index].head; 
  for (i = 1; i < search_start_y; i++) p = p->next; 
  line_count = 1; 
  while (p) 
  { 
    if (forward == TRUE) 
    { 
      offset = 0; 
      if (line_count == 1)  offset = search_start_x - 1; 
    } 
    else 
    { 
      max_pos = p->len; 
      if (line_count == 1)  max_pos = (int) search_start_x - 1; 
    } 
    if (forward == TRUE) 
    { 
      match_index = first_match(p->line + offset, search_string, respect_case); 
    } 
    else 
    { 
      match_index = last_match(p->line, max_pos, search_string, respect_case); 
    } 
    if (match_index != -1) 
    { 
      if (forward) 
      { 
        *found_x  = match_index + 1 + offset; 
        *found_y  = search_start_y + line_count - 1; 
      } 
      else 
      { 
        *found_x = match_index + 1; 
        *found_y = search_start_y - (line_count - 1); 
      } 
      return (TRUE); 
    } 
    if (forward) 
    { 
      p = p->next; 
    } 
    else 
    { 
      p = p->prev; 
    } 
    line_count++;         /* count the number of searched lines */ 
  } 
  return (FALSE); 
}                                     /* end of function search */ 
 
 
/* finds out whether string q is a substring of string p        */ 
/* if so it returns the index of the first match, -1 otherwise  */ 
 
long/*size_t*/ first_match(char p[], char q[], int respect_case) 
//char    p[], q[]; 
//int     respect_case;
{ 
  size_t          len_p, len_q, i, j; 
  char            help_p[MAX_LINE], help_q[MAX_LINE];
  int             letter;  
  unsigned char   c;
  
  strcpy (help_p, p);
  strcpy (help_q, q);
  len_p = strlen (help_p); 
  len_q = strlen (help_q); 

  if (!respect_case)          /* convert both strings to lower-case */
  {
    for (i = 0; i < len_p; i++)
    {
      c = help_p[i];
      letter = (int) c;
      switch (letter)
      {
        case 153: 
                  help_p[i] = 148;
                  break;
        case 142: 
                  help_p[i] = 132;
                  break;
        case 154: 
                  help_p[i] = 129;
                  break;
        default:
                  break;
      }
      if (isalpha (help_p[i])) 
      {
        help_p[i] = (char) tolower (help_p[i]);
      }
    }   
    for (i = 0; i < len_q; i++)
    {
      c = help_q[i];
      letter = (int) c;
      switch (letter)
      {
        case 153: 
                  help_q[i] = 148;
                  break;
        case 142: 
                  help_q[i] = 132;
                  break;
        case 154: 
                  help_q[i] = 129;
                  break;
        default:
                  break;
      }
      if (isalpha (help_q[i])) 
      {
        help_q[i] = (char) tolower (help_q[i]);
      }
    }   
  } 
  for (i = 0; i < len_p; i++) 
  { 
    for (j = 0; (j < len_q && j+i < len_p); j++) 
    { 
      if (help_q[j] != help_p[j+i]) break; 
    } 
    if (j == len_q) return (i); 
  } 
  return (-1); 
} 
 
 
/* finds out whether string q is a substring of the first n chars   */ 
/* of the string p. if so it returns the index of the last match,   */ 
/* -1 otherwise */ 
 
long/*size_t*/ last_match(char p[], int n, char q[], int respect_case) 
//char    p[], q[];
//int     n, respect_case;
{ 
  size_t  i, j, k, len_p, len_q/*, index*/; 
  long						match_index;															// Wegen -1
  char            help_p[MAX_LINE], help_q[MAX_LINE];
  int             letter;
  unsigned char   c;
 
  match_index = -1; 
  strcpy (help_p, p);
  strcpy (help_q, q);
  len_p = strlen (help_p); 
  len_q = strlen (help_q); 
  if (!respect_case)          /* convert both strings to lower-case */
  {
    for (i = 0; i < len_p; i++)
    {
      c = help_p[i];
      letter = (int) c;
      switch (letter)
      {
        case 153: 
                  help_p[i] = 148;
                  break;
        case 142: 
                  help_p[i] = 132;
                  break;
        case 154: 
                  help_p[i] = 129;
                  break;
        default:
                  break;
      }
      if (isalpha (help_p[i])) 
      {
        help_p[i] = (char) tolower (help_p[i]);
      }
    }   
    for (i = 0; i < len_q; i++)
    {
      c = help_q[i];
      letter = (int) c;
      switch (letter)
      {
        case 153: 
                  help_q[i] = 148;
                  break;
        case 142: 
                  help_q[i] = 132;
                  break;
        case 154: 
                  help_q[i] = 129;
                  break;
        default:
                  break;
      }
      if (isalpha (help_q[i])) 
      {
        help_q[i] = (char) tolower (help_q[i]);
      }
    }   
  } 
  k = min ((long) n, (long) len_p); 
  for (i = 0; i < k; i++) 
  { 
    for (j = 0; (j < len_q && j+i < len_p); j++) 
    { 
      if (help_q[j] != help_p[j+i]) break; 
    } 
    if (j == len_q) match_index = max((long)match_index, (long)i); 
  } 
  return (match_index); 
} 
 

/* find the beginning of the next word  */

void find_next_word(int w_index, long *next_curs_x, long *next_curs_y)
/*int   w_index;
long  *next_curs_x;
long  *next_curs_y;*/
{
  long  found_x, found_y;
  long  curs_x, curs_y;
  int   i, found, found_blank;
  LINE_DESC *p;

  curs_x  = windows[w_index].curs_x;  /* start at cursor position */
  curs_y  = windows[w_index].curs_y;
  found         = FALSE;
  found_blank   = FALSE;
  while (!found)
  {                                     /* 1. while start */
    found_blank = search (w_index,  
                          curs_x,    /* start at current position    */
                          curs_y,    /* start at current position    */
                          1,         /* search direction is forward  */
                          " ",       /* look for a blank             */
                          FALSE,     /* case does not matter         */
                          &found_x, 
                          &found_y);
    if (!found_blank)
    {
      p = windows[w_index].head; 
      for (i = 1; i < curs_y + 1; i++) p = p->next; 

      if (curs_y < windows[w_index].doc_length / hzeich)
      {
        found_x = 1;
        while (p->next != NULL && p->line[0] == '\n')
        { 
          p = p->next;
          curs_y++;
        }
        found_y = curs_y + 1;         /* go to start of next line */
      }
      else
      {
        found_x = curs_x;
        found_y = curs_y;
      }
      found = TRUE;
      continue;
    }
    if (found_y > curs_y) 
    {
      p = windows[w_index].head; 
      for (i = 1; i < curs_y + 1; i++) p = p->next; 
      if ((p->line[0] != ' ') && (p->line[0] != '\n'))
      {
        found_x = 1;                    /* go to start of line  */
        found_y = curs_y + 1;
        found   = TRUE;
      }
      else
      {
        curs_x = 1;     
        curs_y++;     
      }
      continue;
    }
    found_x++;                        /* goto next character  */
    p = windows[w_index].head; 
    for (i = 1; i < found_y; i++) p = p->next; 
    if (found_x > p->len)             /* reached end of line ?  */
    {
      found_x = 1;
      found_y++;
      if (found_y > windows[w_index].doc_length / hzeich)
      {
        /* reached end of text  */
        found_y   = windows[w_index].doc_length / hzeich;
        found_x   = p->len;
        found     = TRUE;
        continue;                   /* leave the while loop */      
      }
    }
    if (p->line[found_x-1] == ' ')    
    {
      /* found two consecutive blanks */
      found   = FALSE;              /* go for the next occurrence */
      curs_x  = found_x;
      curs_y  = found_y;
      continue;
    }
    if (p->line[found_x-1] == '\n')   
    {
      /* found a blank at end of line   */
      if (p->next)            /* not at the end of the text */
      {
        found_x = 1;
        found_y++;
        curs_x = 1;
        curs_y = found_y;
        if ((p->next->line[0] != ' ') &&
            (p->next->line[0] != '\n')) 
        {
          found = TRUE;
        }
      }
      else
      {
        found = TRUE;
      }
      continue;
    }
    found = TRUE;
  }                                     /* 1. while end */
  *next_curs_x = found_x;
  *next_curs_y = found_y;
  return;
}


/* return GEMDOS major version number  */ 
 
int gemdos_minor(void) 
{ 
  int vers; 
 
  vers = Sversion (); 
  return (vers >> 8); 
} 
 
 
/* return GEMDOS minor version number  */ 
 
int gemdos_major(void) 
{ 
  int vers; 
 
  vers = Sversion (); 
  return (vers & 0x0F); 
} 
 
 
/* returns TRUE if GEMDOS Version is pre-Version 0.19 */ 
 
int old_gemdos(void) 
{ 
  return (gemdos_major () == 0 && gemdos_minor () < 19); 
} 
 
 
long get_byte_size(int w_index) 
//int   w_index; 
{ 
  long        size; 
  LINE_DESC   *p; 
 
 
  size = 0; 
  for (p = windows[w_index].head; p; p = p->next) size += p->len; 
  return (size); 
} 
 
 
long get_max_line_length(int w_index) 
//int   w_index; 
{ 
  long        size; 
  LINE_DESC   *p; 
 
  size = 0; 
  for (p = windows[w_index].head; p; p = p->next) 
  {
    size = max (size, (long) p->len); 
  }
  return (size); 
} 
 
 
/* keeps window within a specified area (e.g. the desktop)      */ 
 
void snap(GRECT *w1, GRECT *w2) 
//GRECT *w1, *w2;           /* pointers to GRECT structures       */ 
                          /* w1 points to max coordinates and   */ 
                          /* w2 points to the new coordinates   */ 
{ 
  if (w2->g_x < w1->g_x) 
  { 
    w2->g_x = w1->g_x; 
  } 
  if (w2->g_y < w1->g_y) 
  { 
    w2->g_y = w1->g_y; 
  } 
  if ((w2->g_x + w2->g_w) > (w1->g_x + w1->g_w)) 
  { 
    w2->g_x = w1->g_x + w1->g_w - w2->g_w; 
  } 
  if ((w2->g_y + w2->g_h) > (w1->g_y + w1->g_h)) 
  { 
    w2->g_y = w1->g_y + w1->g_h - w2->g_h; 
  } 
  if (w2->g_x < w1->g_x) 
  { 
    w2->g_x = w1->g_x; 
    w2->g_w = w1->g_w; 
  } 
  if (w2->g_y < w1->g_y) 
  { 
    w2->g_y = w1->g_y; 
    w2->g_h = w1->g_h; 
  } 
  return; 
}                         /* end function snap  */ 
 
 
/* aligns coordinate k to a multiple of n */ 
 
int align(int k, int n) 
//int  k,n; 
{ 
  if (n) 
  { 
    k += (n>>1) - 1;      /* k := k + (n/2) -1                    */ 
    k  = n * (k/n);       /* attention: k/n is integer division,  */ 
                          /* i.e. disregard the remainder!        */ 
    return (k); 
  } 
  else 
  { 
    return (k); 
  } 
}                         /* end function align                   */ 
 
 
/*----------------------------------
	Displays system time in menu bar
----------------------------------*/ 
void display_time(short flag)
{ 
  short     i; 
  size_t    x, y, len; 
  char      time_str[MAX_LINE]; 
  char      *time_ptr;
  time_t    timer;
  struct tm	*time_tm;   
  
  timer     = time ((time_t) NULL);
  for (i = 0; i < 25; i++) strcpy (time_str + i, " ");
  if (flag && (timer != -1)) 
  { 
    time_ptr  = ctime (&timer);
    time_tm   = localtime(&timer);
    time_str[0] = LO_CLOCK;           				/* display a little clock     */ 

    strncpy(time_str + 2, time_ptr, 3);    					/* day, month and time  */
    strftime(time_str + 5, 19, " %d-%b-%Y %H:%M", time_tm);
  } 
  len = strlen (time_str); 
  y   = 2;                      				/* pixel offset from top of screen  */ 
  x   = screen.fd_w - (bzeich * len);       				/* start output here    */ 
  graf_mouse(M_OFF, NULL);
  for (i = 0; i < len; i++) 
  { 
    put_graphic_char(time_str[i], x, y, -1); 
    x += bzeich; 
  } 

  graf_mouse(M_ON, NULL);
  return; 
} 
 
 
int rect_equal(GRECT *r1, GRECT *r2) /* are the two rectangles equal ? */ 
//GRECT *r1, *r2; 
{ 
  if ((r1->g_x != r2->g_x) || 
      (r1->g_y != r2->g_y) || 
      (r1->g_w != r2->g_w) || 
      (r1->g_h != r2->g_h)) 
  { 
    return (FALSE); 
  } 
  else 
  { 
    return (TRUE); 
  } 
}             /* end of function rect_equal */ 
 
 
/* Checks whether two given rectangles intersect. If they do, it  */ 
/* returns TRUE and computes the coordinates of the intersection.   */ 
/* Otherwise, it returns FALSE.                   */ 

int rect_intersect (GRECT *r1, GRECT *r2, GRECT *r3) 
//GRECT *r1, *r2, *r3; 
{ 
  int x, y, w, h; 
 
  x = (int) max ((long) r1->g_x, (long) r2->g_x); 
  y = (int) max ((long) r1->g_y, (long) r2->g_y); 
  w = (int) min ((long) r1->g_x + r1->g_w, 
                 (long) r2->g_x + r2->g_w); 
  h = (int) min ((long) r1->g_y + r1->g_h, 
                 (long) r2->g_y + r2->g_h); 
  r3->g_x = x; 
  r3->g_y = y; 
  r3->g_w = w-x; 
  r3->g_h = h-y; 
 
  return ((w > x) && (h > y)); 
}           /* end of function rect_intersect */ 


long max(long a, long b) 
{ 
  return ((a > b ? a : b)); 
} 

 
long min(long a, long b) 
{ 
  return ((a < b ? a : b)); 
} 

/*---------------------------------------
	Go to line
---------------------------------------*/
void goto_line(short w_index, long line) 
{ 
  long  curs_y, doc_h; 
  short send_buffer[MSG_BUFFER];

  graf_mouse(M_OFF, NULL);
  cursor(windows[w_index].handle, 0); 
  windows[w_index].curs_x   = 1; 
  windows[w_index].curs_xs  = 1;    								/* save cursor position */
  line = max (line, (long) 1); 
  line = min (line, (long) (windows[w_index].doc_length / hzeich)); 
  windows[w_index].curs_y = line; 
  if (!cursor_visible_check(w_index) || windows[w_index].doc_x != 0) 
  { 
    windows[w_index].doc_x = 0; 
    curs_y  = (windows[w_index].curs_y - 1) * hzeich; 
    doc_h   = windows[w_index].work.g_h; 
    windows[w_index].doc_y = max((long)(curs_y - doc_h/2), (long)0); 
																	    /* send myself a full redraw message  */ 
    send_buffer[0] = WM_REDRAW; 
    send_buffer[1] = ap_id; 
    send_buffer[2] = 0; 
    send_buffer[3] = windows[w_index].handle; 
    send_buffer[4] = windows[w_index].work.g_x; 
    send_buffer[5] = windows[w_index].work.g_y; 
    send_buffer[6] = windows[w_index].work.g_w; 
    send_buffer[7] = windows[w_index].work.g_h; 
    appl_write(ap_id, (short)sizeof(send_buffer), send_buffer); 
  } 
  cursor(windows[w_index].handle, 1); 
  graf_mouse(M_ON, NULL);
  return; 
} 
 
 
int cfg_read(void) 
{ 
  FILE    *fp; 
  char    read_line[MAX_LINE]; 
  long    value, i; 
 
  /* initialize the configuration with the program's defaults */ 
 
  tab_size_cfg    = DEF_TAB_SIZE; 
  backup_cfg      = DEF_BCK_OPT; 
  clocky_cfg      = DEF_CLOCK_OPT; 
  page_length_cfg = DEF_PAGE_LENGTH; 
  left_margin_cfg = DEF_LEFT_MARGIN; 
  header_cfg      = DEF_HEADER_OPT;
  lines_cfg       = DEF_LINES_OPT;
  showcr_cfg      = DEF_SHOWCR_OPT;
  showpos_cfg     = DEF_SHOWPOS_OPT;
  line_len_cfg    = DEF_LINE_LEN;
  eol_warn_cfg    = DEF_EOL_WARN;
  sea_direct_cfg  = DEF_SEARCH_DIRECTION;
  sea_case_cfg    = DEF_SEARCH_CASE;
  sea_start_cfg   = DEF_SEARCH_START;
  repl_case_cfg   = DEF_REPLACE_CASE; 
  repl_verify_cfg = DEF_REPLACE_VERIFY;
  repl_start_cfg  = DEF_REPLACE_START;
  strcpy (filename_cfg, "");
  strcpy (sea_str_cfg,"");
  strcpy (repl_str_cfg,"");
  strcpy (replby_str_cfg, "");
  
  /* copy configuration data into "current" variables */ 
 
  tab_size        = tab_size_cfg; 
  backup          = backup_cfg; 
  clocky          = clocky_cfg; 
  page_length     = page_length_cfg; 
  left_margin     = left_margin_cfg; 
  header          = header_cfg;
  lines           = lines_cfg;
  showcr          = showcr_cfg;
  showpos         = showpos_cfg;
  line_len        = line_len_cfg;
  eol_warn        = eol_warn_cfg;
  sea_direct      = sea_direct_cfg;
  sea_case        = sea_case_cfg;
  sea_start       = sea_start_cfg;
  repl_case       = repl_case_cfg;  
  repl_verify     = repl_verify_cfg;
  repl_start      = repl_start_cfg;
  strcpy (sea_str,    sea_str_cfg);
  strcpy (repl_str,   repl_str_cfg);
  strcpy (replby_str, replby_str_cfg);
  prg_drive = Dgetdrv (); 
  Dgetpath (prg_path, 0); 
    /* read actual settings from configuration file (if any)  */ 
  if (!(Fsfirst (ALICE_CFG_FILE, 0) == 0))
  {
    return (TRUE);                        /* no config file */
  }
  if ((fp = fopen (ALICE_CFG_FILE, "r")) == (FILE *) NULL) 
  { 
    return (FALSE); 
  } 
  MOUSE_IS_BUSY; 
  while (fgets (read_line, MAX_LINE-1, fp) != NULL) 
                                                  /* read from file */ 
  {                                               /* 1. while start */ 
    i = 0; 
    while (!isdigit(read_line[i]) && i < strlen (read_line)) i++; 
    value = atol (read_line + i); 
    if (strncmp ("tab_size", read_line, strlen ("tab_size")) == 0) 
    { 
      tab_size_cfg = (int) value; 
      continue;
    } 
    if (strncmp ("backup", read_line, strlen ("backup")) == 0) 
    { 
      backup_cfg = (int) value; 
      continue;
    } 
    if (strncmp ("clock", read_line, strlen ("clock")) == 0) 
    { 
      clocky_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("sea_start", read_line, strlen ("sea_start")) == 0) 
    { 
      sea_start_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("sea_case", read_line, strlen ("sea_case")) == 0) 
    { 
      sea_case_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("sea_direct", 
                read_line, 
                strlen ("sea_direct")) == 0) 
    { 
      sea_direct_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("repl_start", 
                read_line, 
                strlen ("repl_start")) == 0) 
    { 
      repl_start_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("repl_case", 
                read_line, 
                strlen ("repl_case")) == 0) 
    { 
      repl_case_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("repl_verify", 
                read_line, 
                strlen ("repl_verify")) == 0) 
    { 
      repl_verify_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("page_length", 
                  read_line, 
                  strlen ("page_length")) == 0) 
    { 
      page_length_cfg = (int) value % 1000;
      continue; 
    } 
    if (strncmp ("left_margin", 
                  read_line, 
                  strlen ("left_margin")) == 0) 
    { 
      left_margin_cfg = (int) value % 100;
      continue; 
    }
    if ((strncmp ("file", read_line, strlen ("file")) == 0) &&
        (strlen (read_line) > strlen ("file=") + 1)         &&
        (strlen (param_filename) == 0))
    {
      strcpy (param_filename, read_line + strlen ("file="));
      strcpy (filename_cfg, param_filename);
      if (filename_cfg[strlen(filename_cfg)-1] == '\n')
      {
        filename_cfg[strlen(filename_cfg)-1] = '\0';
      }
      continue;
    }
    if ((strncmp ("sea_str", 
                  read_line, 
                  strlen ("sea_str")) == 0)           &&
        (strlen (read_line) > strlen ("sea_str=") + 1))
    {
      strcpy (sea_str_cfg, read_line + strlen ("sea_str="));
      if (sea_str_cfg[strlen(sea_str_cfg)-1] == '\n')
      {
        sea_str_cfg[strlen(sea_str_cfg)-1] = '\0';
      }
      continue;
    }
    if ((strncmp ("repl_str", 
                  read_line, 
                  strlen ("repl_str")) == 0)          &&
        (strlen (read_line) > strlen ("repl_str=") + 1))
    {
      strcpy (repl_str_cfg, read_line + strlen ("repl_str="));
      if (repl_str_cfg[strlen(repl_str_cfg)-1] == '\n')
      {
        repl_str_cfg[strlen(repl_str_cfg)-1] = '\0';
      }
      continue;
    }
    if ((strncmp ("replby_str", 
                  read_line, 
                  strlen ("replby_str")) == 0)        &&
        (strlen (read_line) > strlen ("replby_str=") + 1))
    {
      strcpy (replby_str_cfg, read_line + strlen ("replby_str="));
      if (replby_str_cfg[strlen(replby_str_cfg)-1] == '\n')
      {
        replby_str_cfg[strlen(replby_str_cfg)-1] = '\0';
      }
      continue;
    }
    if ((strncmp ("line_number", 
                  read_line, 
                  strlen ("line_number")) == 0) &&
        (param_line == 0))
    { 
      param_line = value;
      line_cfg = param_line;
      continue; 
    }
    if (strncmp ("header", read_line, strlen ("header")) == 0) 
    { 
      header_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("lines", read_line, strlen ("lines")) == 0) 
    { 
      lines_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("showcr", read_line, strlen ("showcr")) == 0) 
    { 
      showcr_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("showpos", read_line, strlen ("showpos")) == 0) 
    { 
      showpos_cfg = (int) value;
      continue; 
    } 
    if (strncmp ("line_len", read_line, strlen ("line_len")) == 0) 
    { 
      line_len_cfg = (int) value % 1000;
      continue; 
    } 
    if (strncmp ("eol_warn", read_line, strlen ("eol_warn")) == 0) 
    { 
      eol_warn_cfg = (int) value;
      continue; 
    } 

  }                                               /* 1. while end   */ 
  fclose (fp);                                    /* close the file */ 
  /* copy configuration data into "current" variables */ 
  tab_size        = tab_size_cfg; 
  backup          = backup_cfg; 
  clocky          = clocky_cfg; 
  page_length     = page_length_cfg; 
  left_margin     = left_margin_cfg; 
  header          = header_cfg;
  lines           = lines_cfg;
  showcr          = showcr_cfg; 
  showpos         = showpos_cfg; 
  line_len        = line_len_cfg; 
  eol_warn        = eol_warn_cfg; 
  sea_direct      = sea_direct_cfg;
  sea_case        = sea_case_cfg;
  sea_start       = sea_start_cfg;
  repl_case       = repl_case_cfg;  
  repl_verify     = repl_verify_cfg;
  repl_start      = repl_start_cfg;
  strcpy (sea_str,    sea_str_cfg);
  strcpy (repl_str,   repl_str_cfg);
  strcpy (replby_str, replby_str_cfg);
  return (TRUE); 
}                                   /* end of function cfg_read */ 


void X_wD_dx(){sprintf (text,"%s%s%s",X_wD_dX1,X_wD_dX2,X_wD_dX3);
say(text);return;} 
void X_wD_dy(){sprintf (text,"%s%s%s",X_wD_dY1,X_wD_dY2,X_wD_dY3);
say(text);return;} 


int cfg_write(void) 
{ 
  int       modified;
  FILE      *fp; 
 
  modified = FALSE;
  if (backup      != backup_cfg)      modified = TRUE;
  if (clocky      != clocky_cfg)      modified = TRUE;
  if (page_length != page_length_cfg) modified = TRUE; 
  if (left_margin != left_margin_cfg) modified = TRUE; 
  if (tab_size    != tab_size_cfg)    modified = TRUE;
  if (header      != header_cfg)      modified = TRUE;
  if (lines       != lines_cfg)       modified = TRUE;
  if (showcr      != showcr_cfg)      modified = TRUE;
  if (showpos     != showpos_cfg)     modified = TRUE;
  if (line_len    != line_len_cfg)    modified = TRUE;
  if (eol_warn    != eol_warn_cfg)    modified = TRUE;
  if (!(strcmp (filename_cfg, param_filename) == 0)) modified = TRUE;
  if (line_cfg    != param_line)      modified = TRUE;
  if (!(strcmp (sea_str,    sea_str_cfg) == 0))     modified = TRUE;
  if (!(strcmp (repl_str,   repl_str_cfg) == 0))    modified = TRUE;
  if (!(strcmp (replby_str, replby_str_cfg) == 0))  modified = TRUE;
  if (sea_start   != sea_start_cfg)   modified = TRUE;
  if (sea_direct  != sea_direct_cfg)  modified = TRUE;
  if (sea_case    != sea_case_cfg)    modified = TRUE;
  if (repl_start  != repl_start_cfg)  modified = TRUE;
  if (repl_case   != repl_case_cfg)   modified = TRUE;
  if (repl_verify != repl_verify_cfg) modified = TRUE;
  if (!modified) return (TRUE);
  MOUSE_IS_BUSY; 
  Dsetdrv (prg_drive); 
  Dsetpath ("\\");
  Dsetpath (prg_path);
  if ((fp = fopen (ALICE_CFG_FILE, "w")) == (FILE *) NULL) 
  { 
    return (FALSE);     /* cannot open file for writing   */
                        /* maybe next time...             */ 
  } 
  if (fseek (fp, 0L,0)) 
  { 
    return (FALSE); 
  } 
  clearerr (fp); 
  fprintf (fp, "*** ALICE configuration file         ***\n\n");
  fprintf (fp, "*** Do not edit this file manually!  ***\n\n");
  fprintf (fp,  
    "%s%d\n%s%d\n%s%d\n%s%d\n%s%d\n%s%s\n%s%ld\n%s%d\n%s%d\n"
    "%s%d\n%s%d\n",
    "backup=",      backup, 
    "clock=",       clocky, 
    "page_length=", page_length, 
    "left_margin=", left_margin, 
    "tab_size=",    tab_size,
    "file=",        param_filename,
    "line_number=", param_line,
    "header=",      header,
    "lines=",       lines,
    "showcr=",      showcr,
    "showpos=",     showpos);
  if (ferror(fp)) 
  { 
    return (FALSE); 
  } 
  fprintf (fp,  
    "%s%d\n%s%d\n%s%d\n%s%d\n%s%d\n%s%d\n%s%s\n%s%s\n%s%s\n"
    "%s%d\n%s%d\n\n", 
    "sea_start=",   sea_start,
    "sea_direct=",  sea_direct,
    "sea_case=",    sea_case,
    "repl_start=",  repl_start,
    "repl_case=",   repl_case,
    "repl_verify=", repl_verify,
    "sea_str=",     sea_str,
    "repl_str=",    repl_str,
    "replby_str=",  replby_str,
    "line_len=" ,   line_len,
    "eol_warn=" ,   eol_warn);
  if (ferror(fp)) 
  { 
    return (FALSE); 
  } 
  fprintf (fp, "*** End of configuration file ***\n\n");
  if (fflush(fp)) 
  { 
    return (FALSE); 
  } 
  if (fclose(fp)) 
  { 
    return (FALSE); 
  } 
  MOUSE_IS_ARROW; 
  return (TRUE); 
}                           /* end of function cfg_write  */ 
 

void disable_menu(void)
{
  menu_ienable (menu_tree, IOPEN,    FALSE); 
  menu_ienable (menu_tree, IRDFILFI, FALSE); 
  menu_ienable (menu_tree, IRDFILBU, FALSE); 
  menu_ienable (menu_tree, ICLOSE,   FALSE); 
  menu_ienable (menu_tree, IDOCINFO, FALSE); 
  menu_ienable (menu_tree, IQUIT,    FALSE); 
  menu_ienable (menu_tree, ISAVE,    FALSE); 
  menu_ienable (menu_tree, ISAVEAS,  FALSE); 
  menu_ienable (menu_tree, IBACK,    FALSE); 
  menu_ienable (menu_tree, IBACKAS,  FALSE); 
  menu_ienable (menu_tree, IFIPRINT, FALSE); 
  menu_ienable (menu_tree, ISEARCH,  FALSE); 
  menu_ienable (menu_tree, IREPL,    FALSE); 
  menu_ienable (menu_tree, IREPSEAR, FALSE); 
  menu_ienable (menu_tree, IBLSTART, FALSE); 
  menu_ienable (menu_tree, IBLEND,   FALSE); 
  menu_ienable (menu_tree, IOPTIONS, FALSE); 
  cap_enable (FALSE); 
  buf_enable (FALSE); 
  return;
}

/*-------------------------------
	Refresh window
-------------------------------*/
void refresh_window(int w_handle)
{
  graf_mouse(M_OFF, NULL);
  cursor(w_handle, 0); 
  full_redraw(w_handle, TRUE);
  cursor(w_handle, 1); 
  graf_mouse(M_ON, NULL);
  return;
}

/*																					Ohne Rckgabewert Fehlermeldung!
void udf(void)
{time_t timer;if(!clocky)return;timer=time((time_t) NULL);
(localtime(&timer))->tm_sec%4?X_wD_dxx:X_wD_dyy;} 
*/
int udf(void)
{time_t timer;if(!clocky)return(0);timer=time((time_t) NULL);
(localtime(&timer))->tm_sec%4?X_wD_dxx:X_wD_dyy;return(0);} 

int number_of_pages(int w_index)
//int   w_index;
{
  long  num_lines;
  int   num_pages, a;
  
  num_lines = windows[w_index].doc_length / hzeich; 
  if (dial_print[HEADYES].ob_state == SELECTED)
  {
    a = page_length - 2;
  }
  else
  {
    a = page_length;
  }
  num_pages = (int) ((num_lines - 1 ) / a);
  num_pages++;
  return (num_pages);
}


int control_key(void)    /* is the control key pressed ? */
{
  short mousex, mousey, mouse_state, keybd_state;

  graf_mkstate (&mousex, &mousey, &mouse_state, &keybd_state);
  return (keybd_state & K_CTRL);
}


int alternate_key(void)    /* is the alternate key pressed ?   */
{
  short mousex, mousey, mouse_state, keybd_state;

  graf_mkstate (&mousex, &mousey, &mouse_state, &keybd_state);
  return (keybd_state & K_ALT);
}


void say(char *string)    /* routine for test output  */ 
//char  *string; 
{ 
  char test[ALERT_MAX_LINES * ALERT_MAX_LINE_LENGTH]; 
 
  strcpy (test, "[0][ "); 
  strcpy (test + strlen (test), string); 
  strcpy (test + strlen (test), " ][ OK ]"); 
  MOUSE_IS_ARROW; 
  form_alert (1, test); 
  return; 
} 
 
 
/* end of file toolbox.c */ 
 
