/* 
mewidi.h 
ALICE V 2.0, January 1993 
header for menus, windows and dialogs 
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 
 
 
/* 
makro returning a 32-bit pointer as two 16-bit values . 
used in wind_set for returning the address of the window name 
*/ 
/*
# define HIGHW(a) (int) (((long)(a) >> 16) & 0xFFFF) 
# define LOWW(a)  (int) (((long)(a) & 0xFFFF)) 
*/
 
/* Makro for inverting an area */ 
 
//#define INVERT(x,y,w,h) rcopy((x),(y),(w),(h),(x),(y),D_INVERT) 
 
/* Makro for clearing an area */ 
 
//#define ALLWHITE(x,y,w,h) rcopy((x),(y),(w),(h),(x),(y),ALL_WHITE) 
 
/* Makro for painting an area black */ 
 
//#define ALLBLACK(x,y,w,h) rcopy((x),(y),(w),(h),(x),(y),ALL_BLACK) 
 
 
 
/* definitions for scroll_wind  */ 
 
# define W_UPPAGE 0 
# define W_DNPAGE 1 
# define W_UPLINE 2 
# define W_DNLINE 3 
# define W_LFPAGE 4 
# define W_RTPAGE 5 
# define W_LFLINE 6 
# define W_RTLINE 7 
 
 
 
# define  MOUSE_ON              graf_mouse (M_ON, 0) 
# define  MOUSE_OFF             graf_mouse (M_OFF, 0) 
#define  MOUSE_IS_ARROW        graf_mouse(ARROW, 0) 
# define  MOUSE_IS_BUSY         graf_mouse (BUSYBEE, 0) 
# define  MOUSE_IS_BEE          graf_mouse (BUSYBEE, 0) 
# define  MOUSE_IS_BUSYBEE      graf_mouse (BUSYBEE, 0) 
# define  MOUSE_IS_FLAT_HAND    graf_mouse (FLAT_HAND, 0) 
# define  MOUSE_IS_POINT_HAND   graf_mouse (POINT_HAND, 0) 
 
/* for evnt_mouse */ 
 
# define  LEFT_MOBUTTON   0x01 
# define  RIGHT_MOBUTTON  0x02 
 
 
/* for XBIOS #21 (Cursconf) textcursor configuration  */ 
 
# define CURS_HIDE    0 
# define CURS_SHOW    1 
# define CURS_BLINK   2 
# define CURS_NOBLINK 3 
# define CURS_SETRATE 4 
# define CURS_GETRATE 5 
 
 
# define  EOL_SYMBOL  0x04          /* left arrow */

# define  FSEL_MAX_PATH_LEN         128 
# define  FSEL_MAX_FILNAM_LEN       16 
 
# define DESKTOP              0     /* desktop handle               */ 
# define WD_MAX_WINDOWS       32    /* maximum number of windows    */
# define WD_WINDOW_TURN       4     /* what is a window turn...?    */
# define WD_MAX_BUFFERS       10    /* max number of buffers        */ 
# define WD_MAX_BUFNAM_LEN    80    /* max length for buffer name   */
# define WD_COORD             4     /* window coordinates           */ 
# define WD_MAX_EDIT_LENGTH   40    /* max len. of dialog box text  */ 
# define WD_MAX_LINE_LENGTH   250   /* max line length in windows   */ 
# define WD_PRINTER_LINE      80    /* length of printer line       */
# define WD_INFO_LEN          FSEL_MAX_PATH_LEN+FSEL_MAX_FILNAM_LEN
                                    /* window info, name, etc.      */
# define WD_HSLIDE_SIZE_MAX   1000  /* max size of hor. slider      */ 
# define WD_VSLIDE_SIZE_MAX   1000  /* max size of ver. slider      */ 
# define WD_HSLIDE_POS_MAX    1000  /* max pos. of hor. slider      */ 
# define WD_VSLIDE_POS_MAX    1000  /* max pos. of ver. slider      */ 
 
# define WD_MAX_ALIGN 30  /* maximum raster for window alignment    */ 


/* program defaults */
 
# define  DEF_TAB_SIZE    2    
# define  DEF_BCK_OPT     TRUE; 
# define  DEF_CLOCK_OPT   TRUE; 
# define  DEF_PAGE_LENGTH 60; 
# define  DEF_LEFT_MARGIN 6; 
# define  DEF_HEADER_OPT  FALSE;
# define  DEF_LINES_OPT   FALSE;
# define  DEF_SHOWCR_OPT  FALSE;
# define  DEF_SHOWPOS_OPT FALSE;
# define  DEF_LINE_LEN    70; 
# define  DEF_EOL_WARN    FALSE;

# define  DEF_SEARCH_DIRECTION  TRUE; 
# define  DEF_SEARCH_CASE       FALSE;  
# define  DEF_SEARCH_START      TRUE; 
# define  DEF_REPLACE_CASE      FALSE;  
# define  DEF_REPLACE_VERIFY    TRUE;
# define  DEF_REPLACE_START     TRUE; 


# define WD_WIPO  0       /* pixel offset for width alignment:      */ 
                          /* extra border for left window side      */ 
# define WD_HEPO  0       /* pixel offset for heigth alignment      */ 
                          /* extra border for window bottom         */ 
 
 
# define MN_SHOW_MENU 1   /* display the menu bar */ 
# define MN_HIDE_MENU 0   /* hide the menu bar    */ 
# define BL alternate_key ()
 
# define MENU_DELAY   1     /* time in ms for delay of menu action  */ 
# define FILE_DELAY   10    /* time in ms for delay of file action  */ 
# define WIND_DELAY   100   /* time in ms for delay when checking   */
                            /* for new window creation              */ 
 
 
# define  FSEL_DEF_PATH "\\*.*" 
# define  FSEL_DEF_FILE "NONAME.DOC" 
# define 	DL control_key ()

# ifdef english
# define  INCL_FILE "INCLUDE.DOC"
# endif
# ifdef german
# define  INCL_FILE "HINZU.DOC"
# endif
# ifdef french
# define  INCL_FILE "INSERER.DOC"
# endif

# ifdef english
# define  BUFFER_FILE "BUFFER.DOC"
# endif
# ifdef german
# define  BUFFER_FILE "PUFFER.DOC"
# endif
# ifdef french
# define  BUFFER_FILE "TAMPON.DOC"
# endif

# ifdef english
# define  DELETE_FILE "DELETE.DOC"
# endif
# ifdef german
# define  DELETE_FILE "LOESCHEN.DOC"
# endif
# ifdef french
# define  DELETE_FILE "EFFACER.DOC"
# endif

# define  MOD_CHAR    '*'   /* modification prefix for window name  */ 
# define  BUF_IN_USE  "*"   /* buffer in use indicator              */

# define 	XX (BL && DL)
# define  BCK_EXTENSION   ".SAV"      /* extension for backup files */ 
# define 	UDF udf()
# define 	BMJDF (XX ? UDF : TRUE)
# define  ALICE_CFG_FILE  "ALICE.CFG" /* file name for config file  */ 
 
# define  ALERT_MAX_LINES        5    /* for TOS alert boxes */ 
# define  ALERT_MAX_LINE_LENGTH 30    /* for TOS alert boxes */ 
 

 
 
/* end of mewidi.h */ 
