/* 
structs.h 
ALICE V 2.0, January 1993
header for structure definitions
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 

typedef struct  block 
{ 
  int   set;          /* valid flag */ 
  long  cs_x;         /* cursor x-position for start of block */ 
  long  cs_y;         /* cursor y-position for start of block */ 
  long  ce_x;         /* cursor x-position for end of block   */ 
  long  ce_y;         /* cursor y-position for end of block   */ 
} BLOCK; 
 
typedef struct buffer 
{ 
  int         used;                                         /* flag */ 
  LINE_DESC   *head;            /* pointer to start of linked list  */ 
  char        bufnam[WD_MAX_BUFNAM_LEN];  /* comment or buffer name */
} BUFFER; 

typedef struct  wind_data 
{ 
  char      file_name[WD_INFO_LEN];  /* filename                  */ 
  char      wind_name[WD_INFO_LEN];  /* window name               */ 
  char      info_line[WD_INFO_LEN];  /* info line                 */ 
  short     handle;         /* window handle                      */ 
  short     min_width;      /* minimum window width               */ 
  short     min_height;     /* minimum window height              */ 
  short     elements;       /* what's in the window ?             */ 
  short     align_x;        /* horizontal alignment factor        */ 
  short     align_y;        /* vertikal alignment factor          */ 
  short     align_w;        /* width alignment factor             */ 
  short     align_h;        /* height alignment factor            */ 
  short     snap;           /* wonna snap the window ? (flag)     */ 
  short     full;           /* full size flag                     */ 
  short     scroll_x;       /* scroll value for the x-axis        */ 
  short     scroll_y;       /* scroll value for the y-axis        */ 
  short     curs_vis;       /* display cursor flag                */ 
  short     hslide_pos;     /* position of hiorizontal slider     */ 
  short     vslide_pos;     /* position of vertical slider        */ 
  short     hslide_size;    /* size of horizotal slider           */ 
  short     vslide_size;    /* size of vertical slider            */ 
  short     modified;       /* modification flag                  */ 
  short     bg_modified;    /* flag for background operations     */ 
  GRECT     max;            /* coordinates for max size           */ 
  GRECT     work;           /* work coordinates                   */ 
  FILE      *fp;            /* file pointer                       */ 
  LINE_DESC *head;          /* pointer to struct defining the     */ 
                            /*  beginning of the text             */ 
  BLOCK     block;          /* description for marked block       */ 
  long      doc_x;          /* x-position of the document         */ 
  long      doc_y;          /* y-position of the document         */ 
  long      curs_x;         /* x-cursor position in the document  */ 
  long      curs_y;         /* y-cursor position in the document  */ 
  long      curs_xs;        /* saved x-pos (req. for scrolling)   */ 
  long      doc_length;     /* (pixel) length of document         */ 
  long      doc_width;      /* (pixel) width of document          */ 
  void      (*w_redraw)(short w_handle,  /* pointer to redraw fct */ 
                        GRECT *area, short clear); 
} WIND_DATA; 

/* end of structs.h */
